SDL_video.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_pixels.h"`
`#include "SDL_rect.h"`
`#include "SDL_surface.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_video.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | SDL_DisplayMode

## Macros

#define | SDL_WINDOWPOS_UNDEFINED_MASK 0x1FFF0000u
#define | SDL_WINDOWPOS_UNDEFINED_DISPLAY(X)
#define | SDL_WINDOWPOS_UNDEFINED SDL_WINDOWPOS_UNDEFINED_DISPLAY(0)
#define | SDL_WINDOWPOS_ISUNDEFINED(X)
#define | SDL_WINDOWPOS_CENTERED_MASK 0x2FFF0000u
#define | SDL_WINDOWPOS_CENTERED_DISPLAY(X)
#define | SDL_WINDOWPOS_CENTERED SDL_WINDOWPOS_CENTERED_DISPLAY(0)
#define | SDL_WINDOWPOS_ISCENTERED(X)

## Typedefs

typedef struct SDL_Window | SDL_Window
typedef void * | SDL_GLContext
typedef SDL_HitTestResult(* | SDL_HitTest) (SDL_Window *win, const SDL_Point *area, void *data)

## Enumerations

enum

SDL_WindowFlags {
SDL_WINDOW_FULLSCREEN = 0x00000001 ,
SDL_WINDOW_OPENGL = 0x00000002 ,
SDL_WINDOW_SHOWN = 0x00000004 ,
SDL_WINDOW_HIDDEN = 0x00000008 ,
SDL_WINDOW_BORDERLESS = 0x00000010 ,
SDL_WINDOW_RESIZABLE = 0x00000020 ,
SDL_WINDOW_MINIMIZED = 0x00000040 ,
SDL_WINDOW_MAXIMIZED = 0x00000080 ,
SDL_WINDOW_MOUSE_GRABBED = 0x00000100 ,
SDL_WINDOW_INPUT_FOCUS = 0x00000200 ,
SDL_WINDOW_MOUSE_FOCUS = 0x00000400 ,
SDL_WINDOW_FULLSCREEN_DESKTOP = ( SDL_WINDOW_FULLSCREEN | 0x00001000 ) ,
SDL_WINDOW_FOREIGN = 0x00000800 ,
SDL_WINDOW_ALLOW_HIGHDPI = 0x00002000 ,
SDL_WINDOW_MOUSE_CAPTURE = 0x00004000 ,
SDL_WINDOW_ALWAYS_ON_TOP = 0x00008000 ,
SDL_WINDOW_SKIP_TASKBAR = 0x00010000 ,
SDL_WINDOW_UTILITY = 0x00020000 ,
SDL_WINDOW_TOOLTIP = 0x00040000 ,
SDL_WINDOW_POPUP_MENU = 0x00080000 ,
SDL_WINDOW_KEYBOARD_GRABBED = 0x00100000 ,
SDL_WINDOW_VULKAN = 0x10000000 ,
SDL_WINDOW_METAL = 0x20000000 ,
SDL_WINDOW_INPUT_GRABBED = SDL_WINDOW_MOUSE_GRABBED
}

enum

SDL_WindowEventID {
SDL_WINDOWEVENT_NONE ,
SDL_WINDOWEVENT_SHOWN ,
SDL_WINDOWEVENT_HIDDEN ,
SDL_WINDOWEVENT_EXPOSED ,
SDL_WINDOWEVENT_MOVED ,
SDL_WINDOWEVENT_RESIZED ,
SDL_WINDOWEVENT_SIZE_CHANGED ,
SDL_WINDOWEVENT_MINIMIZED ,
SDL_WINDOWEVENT_MAXIMIZED ,
SDL_WINDOWEVENT_RESTORED ,
SDL_WINDOWEVENT_ENTER ,
SDL_WINDOWEVENT_LEAVE ,
SDL_WINDOWEVENT_FOCUS_GAINED ,
SDL_WINDOWEVENT_FOCUS_LOST ,
SDL_WINDOWEVENT_CLOSE ,
SDL_WINDOWEVENT_TAKE_FOCUS ,
SDL_WINDOWEVENT_HIT_TEST ,
SDL_WINDOWEVENT_ICCPROF_CHANGED ,
SDL_WINDOWEVENT_DISPLAY_CHANGED
}

enum | SDL_DisplayEventID { SDL_DISPLAYEVENT_NONE , SDL_DISPLAYEVENT_ORIENTATION , SDL_DISPLAYEVENT_CONNECTED , SDL_DISPLAYEVENT_DISCONNECTED , SDL_DISPLAYEVENT_MOVED }
enum | SDL_DisplayOrientation { SDL_ORIENTATION_UNKNOWN , SDL_ORIENTATION_LANDSCAPE , SDL_ORIENTATION_LANDSCAPE_FLIPPED , SDL_ORIENTATION_PORTRAIT , SDL_ORIENTATION_PORTRAIT_FLIPPED }
enum | SDL_FlashOperation { SDL_FLASH_CANCEL , SDL_FLASH_BRIEFLY , SDL_FLASH_UNTIL_FOCUSED }

enum

SDL_GLattr {
SDL_GL_RED_SIZE ,
SDL_GL_GREEN_SIZE ,
SDL_GL_BLUE_SIZE ,
SDL_GL_ALPHA_SIZE ,
SDL_GL_BUFFER_SIZE ,
SDL_GL_DOUBLEBUFFER ,
SDL_GL_DEPTH_SIZE ,
SDL_GL_STENCIL_SIZE ,
SDL_GL_ACCUM_RED_SIZE ,
SDL_GL_ACCUM_GREEN_SIZE ,
SDL_GL_ACCUM_BLUE_SIZE ,
SDL_GL_ACCUM_ALPHA_SIZE ,
SDL_GL_STEREO ,
SDL_GL_MULTISAMPLEBUFFERS ,
SDL_GL_MULTISAMPLESAMPLES ,
SDL_GL_ACCELERATED_VISUAL ,
SDL_GL_RETAINED_BACKING ,
SDL_GL_CONTEXT_MAJOR_VERSION ,
SDL_GL_CONTEXT_MINOR_VERSION ,
SDL_GL_CONTEXT_EGL ,
SDL_GL_CONTEXT_FLAGS ,
SDL_GL_CONTEXT_PROFILE_MASK ,
SDL_GL_SHARE_WITH_CURRENT_CONTEXT ,
SDL_GL_FRAMEBUFFER_SRGB_CAPABLE ,
SDL_GL_CONTEXT_RELEASE_BEHAVIOR ,
SDL_GL_CONTEXT_RESET_NOTIFICATION ,
SDL_GL_CONTEXT_NO_ERROR ,
SDL_GL_FLOATBUFFERS
}

enum | SDL_GLprofile { SDL_GL_CONTEXT_PROFILE_CORE = 0x0001 , SDL_GL_CONTEXT_PROFILE_COMPATIBILITY = 0x0002 , SDL_GL_CONTEXT_PROFILE_ES = 0x0004 }
enum | SDL_GLcontextFlag { SDL_GL_CONTEXT_DEBUG_FLAG = 0x0001 , SDL_GL_CONTEXT_FORWARD_COMPATIBLE_FLAG = 0x0002 , SDL_GL_CONTEXT_ROBUST_ACCESS_FLAG = 0x0004 , SDL_GL_CONTEXT_RESET_ISOLATION_FLAG = 0x0008 }
enum | SDL_GLcontextReleaseFlag { SDL_GL_CONTEXT_RELEASE_BEHAVIOR_NONE = 0x0000 , SDL_GL_CONTEXT_RELEASE_BEHAVIOR_FLUSH = 0x0001 }
enum | SDL_GLContextResetNotification { SDL_GL_CONTEXT_RESET_NO_NOTIFICATION = 0x0000 , SDL_GL_CONTEXT_RESET_LOSE_CONTEXT = 0x0001 }
enum | SDL_HitTestResult { SDL_HITTEST_NORMAL , SDL_HITTEST_DRAGGABLE , SDL_HITTEST_RESIZE_TOPLEFT , SDL_HITTEST_RESIZE_TOP , SDL_HITTEST_RESIZE_TOPRIGHT , SDL_HITTEST_RESIZE_RIGHT , SDL_HITTEST_RESIZE_BOTTOMRIGHT , SDL_HITTEST_RESIZE_BOTTOM , SDL_HITTEST_RESIZE_BOTTOMLEFT , SDL_HITTEST_RESIZE_LEFT }

## Functions

int | SDL_GetNumVideoDrivers (void)
const char * | SDL_GetVideoDriver (int index)
int | SDL_VideoInit (const char *driver_name)
void | SDL_VideoQuit (void)
const char * | SDL_GetCurrentVideoDriver (void)
int | SDL_GetNumVideoDisplays (void)
const char * | SDL_GetDisplayName (int displayIndex)
int | SDL_GetDisplayBounds (int displayIndex, SDL_Rect *rect)
int | SDL_GetDisplayUsableBounds (int displayIndex, SDL_Rect *rect)
int | SDL_GetDisplayDPI (int displayIndex, float *ddpi, float *hdpi, float *vdpi)
SDL_DisplayOrientation | SDL_GetDisplayOrientation (int displayIndex)
int | SDL_GetNumDisplayModes (int displayIndex)
int | SDL_GetDisplayMode (int displayIndex, int modeIndex, SDL_DisplayMode *mode)
int | SDL_GetDesktopDisplayMode (int displayIndex, SDL_DisplayMode *mode)
int | SDL_GetCurrentDisplayMode (int displayIndex, SDL_DisplayMode *mode)
SDL_DisplayMode * | SDL_GetClosestDisplayMode (int displayIndex, const SDL_DisplayMode *mode, SDL_DisplayMode *closest)
int | SDL_GetPointDisplayIndex (const SDL_Point *point)
int | SDL_GetRectDisplayIndex (const SDL_Rect *rect)
int | SDL_GetWindowDisplayIndex (SDL_Window *window)
int | SDL_SetWindowDisplayMode (SDL_Window *window, const SDL_DisplayMode *mode)
int | SDL_GetWindowDisplayMode (SDL_Window *window, SDL_DisplayMode *mode)
void * | SDL_GetWindowICCProfile (SDL_Window *window, size_t *size)
Uint32 | SDL_GetWindowPixelFormat (SDL_Window *window)
SDL_Window * | SDL_CreateWindow (const char *title, int x, int y, int w, int h, Uint32 flags)
SDL_Window * | SDL_CreateWindowFrom (const void *data)
Uint32 | SDL_GetWindowID (SDL_Window *window)
SDL_Window * | SDL_GetWindowFromID (Uint32 id)
Uint32 | SDL_GetWindowFlags (SDL_Window *window)
void | SDL_SetWindowTitle (SDL_Window *window, const char *title)
const char * | SDL_GetWindowTitle (SDL_Window *window)
void | SDL_SetWindowIcon (SDL_Window *window, SDL_Surface *icon)
void * | SDL_SetWindowData (SDL_Window *window, const char *name, void *userdata)
void * | SDL_GetWindowData (SDL_Window *window, const char *name)
void | SDL_SetWindowPosition (SDL_Window *window, int x, int y)
void | SDL_GetWindowPosition (SDL_Window *window, int *x, int *y)
void | SDL_SetWindowSize (SDL_Window *window, int w, int h)
void | SDL_GetWindowSize (SDL_Window *window, int *w, int *h)
int | SDL_GetWindowBordersSize (SDL_Window *window, int *top, int *left, int *bottom, int *right)
void | SDL_GetWindowSizeInPixels (SDL_Window *window, int *w, int *h)
void | SDL_SetWindowMinimumSize (SDL_Window *window, int min_w, int min_h)
void | SDL_GetWindowMinimumSize (SDL_Window *window, int *w, int *h)
void | SDL_SetWindowMaximumSize (SDL_Window *window, int max_w, int max_h)
void | SDL_GetWindowMaximumSize (SDL_Window *window, int *w, int *h)
void | SDL_SetWindowBordered (SDL_Window *window, SDL_bool bordered)
void | SDL_SetWindowResizable (SDL_Window *window, SDL_bool resizable)
void | SDL_SetWindowAlwaysOnTop (SDL_Window *window, SDL_bool on_top)
void | SDL_ShowWindow (SDL_Window *window)
void | SDL_HideWindow (SDL_Window *window)
void | SDL_RaiseWindow (SDL_Window *window)
void | SDL_MaximizeWindow (SDL_Window *window)
void | SDL_MinimizeWindow (SDL_Window *window)
void | SDL_RestoreWindow (SDL_Window *window)
int | SDL_SetWindowFullscreen (SDL_Window *window, Uint32 flags)
SDL_bool | SDL_HasWindowSurface (SDL_Window *window)
SDL_Surface * | SDL_GetWindowSurface (SDL_Window *window)
int | SDL_UpdateWindowSurface (SDL_Window *window)
int | SDL_UpdateWindowSurfaceRects (SDL_Window *window, const SDL_Rect *rects, int numrects)
int | SDL_DestroyWindowSurface (SDL_Window *window)
void | SDL_SetWindowGrab (SDL_Window *window, SDL_bool grabbed)
void | SDL_SetWindowKeyboardGrab (SDL_Window *window, SDL_bool grabbed)
void | SDL_SetWindowMouseGrab (SDL_Window *window, SDL_bool grabbed)
SDL_bool | SDL_GetWindowGrab (SDL_Window *window)
SDL_bool | SDL_GetWindowKeyboardGrab (SDL_Window *window)
SDL_bool | SDL_GetWindowMouseGrab (SDL_Window *window)
SDL_Window * | SDL_GetGrabbedWindow (void)
int | SDL_SetWindowMouseRect (SDL_Window *window, const SDL_Rect *rect)
const SDL_Rect * | SDL_GetWindowMouseRect (SDL_Window *window)
int | SDL_SetWindowBrightness (SDL_Window *window, float brightness)
float | SDL_GetWindowBrightness (SDL_Window *window)
int | SDL_SetWindowOpacity (SDL_Window *window, float opacity)
int | SDL_GetWindowOpacity (SDL_Window *window, float *out_opacity)
int | SDL_SetWindowModalFor (SDL_Window *modal_window, SDL_Window *parent_window)
int | SDL_SetWindowInputFocus (SDL_Window *window)
int | SDL_SetWindowGammaRamp (SDL_Window *window, const Uint16 *red, const Uint16 *green, const Uint16 *blue)
int | SDL_GetWindowGammaRamp (SDL_Window *window, Uint16 *red, Uint16 *green, Uint16 *blue)
int | SDL_SetWindowHitTest (SDL_Window *window, SDL_HitTest callback, void *callback_data)
int | SDL_FlashWindow (SDL_Window *window, SDL_FlashOperation operation)
void | SDL_DestroyWindow (SDL_Window *window)
SDL_bool | SDL_IsScreenSaverEnabled (void)
void | SDL_EnableScreenSaver (void)
void | SDL_DisableScreenSaver (void)
OpenGL support functions
int | SDL_GL_LoadLibrary (const char *path)
void * | SDL_GL_GetProcAddress (const char *proc)
void | SDL_GL_UnloadLibrary (void)
SDL_bool | SDL_GL_ExtensionSupported (const char *extension)
void | SDL_GL_ResetAttributes (void)
int | SDL_GL_SetAttribute (SDL_GLattr attr, int value)
int | SDL_GL_GetAttribute (SDL_GLattr attr, int *value)
SDL_GLContext | SDL_GL_CreateContext (SDL_Window *window)
int | SDL_GL_MakeCurrent (SDL_Window *window, SDL_GLContext context)
SDL_Window * | SDL_GL_GetCurrentWindow (void)
SDL_GLContext | SDL_GL_GetCurrentContext (void)
void | SDL_GL_GetDrawableSize (SDL_Window *window, int *w, int *h)
int | SDL_GL_SetSwapInterval (int interval)
int | SDL_GL_GetSwapInterval (void)
void | SDL_GL_SwapWindow (SDL_Window *window)
void | SDL_GL_DeleteContext (SDL_GLContext context)

## Macro Definition Documentation

## SDL_WINDOWPOS_CENTERED

#define SDL_WINDOWPOS_CENTERED SDL_WINDOWPOS_CENTERED_DISPLAY(0)

Definition at line 147 of file SDL_video.h.

## SDL_WINDOWPOS_CENTERED_DISPLAY

#define SDL_WINDOWPOS_CENTERED_DISPLAY | ( |  | X | ) |

Value:
(SDL_WINDOWPOS_CENTERED_MASK|(X))
SDL_WINDOWPOS_CENTERED_MASK
#define SDL_WINDOWPOS_CENTERED_MASK
Definition SDL_video.h:145

Definition at line 146 of file SDL_video.h.

## SDL_WINDOWPOS_CENTERED_MASK

#define SDL_WINDOWPOS_CENTERED_MASK 0x2FFF0000u

Used to indicate that the window position should be centered.

Definition at line 145 of file SDL_video.h.

## SDL_WINDOWPOS_ISCENTERED

#define SDL_WINDOWPOS_ISCENTERED | ( |  | X | ) |

Value:
(((X)&0xFFFF0000) == SDL_WINDOWPOS_CENTERED_MASK)

Definition at line 148 of file SDL_video.h.

#define SDL_WINDOWPOS_ISCENTERED(X) \
(((X)&0xFFFF0000) == SDL_WINDOWPOS_CENTERED_MASK)

## SDL_WINDOWPOS_ISUNDEFINED

#define SDL_WINDOWPOS_ISUNDEFINED | ( |  | X | ) |

Value:
(((X)&0xFFFF0000) == SDL_WINDOWPOS_UNDEFINED_MASK)
SDL_WINDOWPOS_UNDEFINED_MASK
#define SDL_WINDOWPOS_UNDEFINED_MASK
Definition SDL_video.h:136

Definition at line 139 of file SDL_video.h.

#define SDL_WINDOWPOS_ISUNDEFINED(X) \
(((X)&0xFFFF0000) == SDL_WINDOWPOS_UNDEFINED_MASK)

## SDL_WINDOWPOS_UNDEFINED

#define SDL_WINDOWPOS_UNDEFINED SDL_WINDOWPOS_UNDEFINED_DISPLAY(0)

Definition at line 138 of file SDL_video.h.

## SDL_WINDOWPOS_UNDEFINED_DISPLAY

#define SDL_WINDOWPOS_UNDEFINED_DISPLAY | ( |  | X | ) |

Value:
(SDL_WINDOWPOS_UNDEFINED_MASK|(X))

Definition at line 137 of file SDL_video.h.

## SDL_WINDOWPOS_UNDEFINED_MASK

#define SDL_WINDOWPOS_UNDEFINED_MASK 0x1FFF0000u

Used to indicate that you don't care what the window position is.

Definition at line 136 of file SDL_video.h.

## Typedef Documentation

## SDL_GLContext

typedef void* SDL_GLContext

An opaque handle to an OpenGL context.

See also
  SDL_GL_CreateContext

Definition at line 221 of file SDL_video.h.

## SDL_HitTest

typedef SDL_HitTestResult(* SDL_HitTest) (SDL_Window *win, const SDL_Point *area, void *data)

Callback used for hit-testing.

Parameters

  win | the SDL_Window where hit-testing was set on.
  area | an SDL_Point which should be hit-tested.
  data | what was passed as callback_data to SDL_SetWindowHitTest().

Returns
  an SDL_HitTestResult value.

See also
  SDL_SetWindowHitTest

Definition at line 1779 of file SDL_video.h.

## SDL_Window

typedef struct SDL_Window SDL_Window

The opaque type used to identify a window.

See also
  SDL_CreateWindow
  SDL_CreateWindowFrom
  SDL_DestroyWindow
  SDL_FlashWindow
  SDL_GetWindowData
  SDL_GetWindowFlags
  SDL_GetWindowGrab
  SDL_GetWindowKeyboardGrab
  SDL_GetWindowMouseGrab
  SDL_GetWindowPosition
  SDL_GetWindowSize
  SDL_GetWindowTitle
  SDL_HideWindow
  SDL_MaximizeWindow
  SDL_MinimizeWindow
  SDL_RaiseWindow
  SDL_RestoreWindow
  SDL_SetWindowData
  SDL_SetWindowFullscreen
  SDL_SetWindowGrab
  SDL_SetWindowKeyboardGrab
  SDL_SetWindowMouseGrab
  SDL_SetWindowIcon
  SDL_SetWindowPosition
  SDL_SetWindowSize
  SDL_SetWindowBordered
  SDL_SetWindowResizable
  SDL_SetWindowTitle
  SDL_ShowWindow

Definition at line 95 of file SDL_video.h.

## Enumeration Type Documentation

## SDL_DisplayEventID

enum SDL_DisplayEventID

Event subtype for display events

Enumerator
SDL_DISPLAYEVENT_NONE | Never used
SDL_DISPLAYEVENT_ORIENTATION | Display orientation has changed to data1
SDL_DISPLAYEVENT_CONNECTED | Display has been added to the system
SDL_DISPLAYEVENT_DISCONNECTED | Display has been removed from the system
SDL_DISPLAYEVENT_MOVED | Display has changed position

Definition at line 185 of file SDL_video.h.

{
SDL_DISPLAYEVENT_NONE, /**< Never used */
SDL_DISPLAYEVENT_ORIENTATION, /**< Display orientation has changed to data1 */
SDL_DISPLAYEVENT_CONNECTED, /**< Display has been added to the system */
SDL_DISPLAYEVENT_DISCONNECTED, /**< Display has been removed from the system */
SDL_DISPLAYEVENT_MOVED /**< Display has changed position */
} SDL_DisplayEventID;
SDL_DisplayEventID
SDL_DisplayEventID
Definition SDL_video.h:186
SDL_DISPLAYEVENT_NONE
@ SDL_DISPLAYEVENT_NONE
Definition SDL_video.h:187
SDL_DISPLAYEVENT_MOVED
@ SDL_DISPLAYEVENT_MOVED
Definition SDL_video.h:191
SDL_DISPLAYEVENT_ORIENTATION
@ SDL_DISPLAYEVENT_ORIENTATION
Definition SDL_video.h:188
SDL_DISPLAYEVENT_DISCONNECTED
@ SDL_DISPLAYEVENT_DISCONNECTED
Definition SDL_video.h:190
SDL_DISPLAYEVENT_CONNECTED
@ SDL_DISPLAYEVENT_CONNECTED
Definition SDL_video.h:189

## SDL_DisplayOrientation

enum SDL_DisplayOrientation

Display orientation

Enumerator
SDL_ORIENTATION_UNKNOWN | The display orientation can't be determined
SDL_ORIENTATION_LANDSCAPE | The display is in landscape mode, with the right side up, relative to portrait mode
SDL_ORIENTATION_LANDSCAPE_FLIPPED | The display is in landscape mode, with the left side up, relative to portrait mode
SDL_ORIENTATION_PORTRAIT | The display is in portrait mode
SDL_ORIENTATION_PORTRAIT_FLIPPED | The display is in portrait mode, upside down

Definition at line 197 of file SDL_video.h.

{
SDL_ORIENTATION_UNKNOWN, /**< The display orientation can't be determined */
SDL_ORIENTATION_LANDSCAPE, /**< The display is in landscape mode, with the right side up, relative to portrait mode */
SDL_ORIENTATION_LANDSCAPE_FLIPPED, /**< The display is in landscape mode, with the left side up, relative to portrait mode */
SDL_ORIENTATION_PORTRAIT, /**< The display is in portrait mode */
SDL_ORIENTATION_PORTRAIT_FLIPPED /**< The display is in portrait mode, upside down */
} SDL_DisplayOrientation;
SDL_DisplayOrientation
SDL_DisplayOrientation
Definition SDL_video.h:198
SDL_ORIENTATION_LANDSCAPE
@ SDL_ORIENTATION_LANDSCAPE
Definition SDL_video.h:200
SDL_ORIENTATION_PORTRAIT
@ SDL_ORIENTATION_PORTRAIT
Definition SDL_video.h:202
SDL_ORIENTATION_PORTRAIT_FLIPPED
@ SDL_ORIENTATION_PORTRAIT_FLIPPED
Definition SDL_video.h:203
SDL_ORIENTATION_LANDSCAPE_FLIPPED
@ SDL_ORIENTATION_LANDSCAPE_FLIPPED
Definition SDL_video.h:201
SDL_ORIENTATION_UNKNOWN
@ SDL_ORIENTATION_UNKNOWN
Definition SDL_video.h:199

## SDL_FlashOperation

enum SDL_FlashOperation

Window flash operation

Enumerator
SDL_FLASH_CANCEL | Cancel any window flash state
SDL_FLASH_BRIEFLY | Flash the window briefly to get attention
SDL_FLASH_UNTIL_FOCUSED | Flash the window until it gets focus

Definition at line 209 of file SDL_video.h.

{
SDL_FLASH_CANCEL, /**< Cancel any window flash state */
SDL_FLASH_BRIEFLY, /**< Flash the window briefly to get attention */
SDL_FLASH_UNTIL_FOCUSED /**< Flash the window until it gets focus */
} SDL_FlashOperation;
SDL_FlashOperation
SDL_FlashOperation
Definition SDL_video.h:210
SDL_FLASH_UNTIL_FOCUSED
@ SDL_FLASH_UNTIL_FOCUSED
Definition SDL_video.h:213
SDL_FLASH_BRIEFLY
@ SDL_FLASH_BRIEFLY
Definition SDL_video.h:212
SDL_FLASH_CANCEL
@ SDL_FLASH_CANCEL
Definition SDL_video.h:211

## SDL_GLattr

enum SDL_GLattr

OpenGL configuration attributes.

While you can set most OpenGL attributes normally, the attributes listed above must be known before SDL creates the window that will be used with the OpenGL context. These attributes are set and read with SDL_GL_SetAttribute and SDL_GL_GetAttribute.

In some cases, these attributes are minimum requests; the GL does not promise to give you exactly what you asked for. It's possible to ask for a 16-bit depth buffer and get a 24-bit one instead, for example, or to ask for no stencil buffer and still have one available. Context creation should fail if the GL can't provide your requested attributes at a minimum, but you should check to see exactly what you got.

Multisample anti-aliasing is a type of full screen anti-aliasing. Multipsampling defaults to off but can be turned on by setting SDL_GL_MULTISAMPLEBUFFERS to 1 and SDL_GL_MULTISAMPLESAMPLES to a value greater than 0. Typical values are 2 and 4.

SDL_GL_CONTEXT_PROFILE_MASK determines the type of context created, while both SDL_GL_CONTEXT_MAJOR_VERSION and SDL_GL_CONTEXT_MINOR_VERSION determine which version. All three attributes must be set prior to creating the first window, and in general you can't change the value of SDL_GL_CONTEXT_PROFILE_MASK without first destroying all windows created with the previous setting.

SDL_GL_CONTEXT_RELEASE_BEHAVIOR can be set to SDL_GL_CONTEXT_RELEASE_BEHAVIOR_NONE or SDL_GL_CONTEXT_RELEASE_BEHAVIOR_FLUSH.

Enumerator
SDL_GL_RED_SIZE | the minimum number of bits for the red channel of the color buffer; defaults to 3.
SDL_GL_GREEN_SIZE | the minimum number of bits for the green channel of the color buffer; defaults to 3.
SDL_GL_BLUE_SIZE | the minimum number of bits for the blue channel of the color buffer; defaults to 2.
SDL_GL_ALPHA_SIZE | the minimum number of bits for the alpha channel of the color buffer; defaults to 0.
SDL_GL_BUFFER_SIZE | the minimum number of bits for frame buffer size; defaults to 0.
SDL_GL_DOUBLEBUFFER | whether the output is single or double buffered; defaults to double buffering on.
SDL_GL_DEPTH_SIZE | the minimum number of bits in the depth buffer; defaults to 16.
SDL_GL_STENCIL_SIZE | the minimum number of bits in the stencil buffer; defaults to 0.
SDL_GL_ACCUM_RED_SIZE | the minimum number of bits for the red channel of the accumulation buffer; defaults to 0.
SDL_GL_ACCUM_GREEN_SIZE | the minimum number of bits for the green channel of the accumulation buffer; defaults to 0.
SDL_GL_ACCUM_BLUE_SIZE | the minimum number of bits for the blue channel of the accumulation buffer; defaults to 0.
SDL_GL_ACCUM_ALPHA_SIZE | the minimum number of bits for the alpha channel of the accumulation buffer; defaults to 0.
SDL_GL_STEREO | whether the output is stereo 3D; defaults to off.
SDL_GL_MULTISAMPLEBUFFERS | the number of buffers used for multisample anti-aliasing; defaults to 0.
SDL_GL_MULTISAMPLESAMPLES | the number of samples used around the current pixel used for multisample anti-aliasing.
SDL_GL_ACCELERATED_VISUAL | set to 1 to require hardware acceleration, set to 0 to force software rendering; defaults to allow either.
SDL_GL_RETAINED_BACKING | not used (deprecated).
SDL_GL_CONTEXT_MAJOR_VERSION | OpenGL context major version.
SDL_GL_CONTEXT_MINOR_VERSION | OpenGL context minor version.
SDL_GL_CONTEXT_EGL | deprecated: set SDL_GL_CONTEXT_PROFILE_MASK to SDL_GL_CONTEXT_PROFILE_ES to enable instead.
SDL_GL_CONTEXT_FLAGS | some combination of 0 or more of elements of the SDL_GLcontextFlag enumeration; defaults to 0.
SDL_GL_CONTEXT_PROFILE_MASK | type of GL context (Core, Compatibility, ES). See SDL_GLprofile; default value depends on platform.
SDL_GL_SHARE_WITH_CURRENT_CONTEXT | OpenGL context sharing; defaults to 0.
SDL_GL_FRAMEBUFFER_SRGB_CAPABLE | requests sRGB capable visual; defaults to 0. (>= SDL 2.0.1)
SDL_GL_CONTEXT_RELEASE_BEHAVIOR | sets context the release behavior; defaults to 1. (>= SDL 2.0.4)
SDL_GL_CONTEXT_RESET_NOTIFICATION |
SDL_GL_CONTEXT_NO_ERROR |
SDL_GL_FLOATBUFFERS |

Definition at line 256 of file SDL_video.h.

{
SDL_GL_RED_SIZE, /**< the minimum number of bits for the red channel of the color buffer; defaults to 3. */
SDL_GL_GREEN_SIZE, /**< the minimum number of bits for the green channel of the color buffer; defaults to 3. */
SDL_GL_BLUE_SIZE, /**< the minimum number of bits for the blue channel of the color buffer; defaults to 2. */
SDL_GL_ALPHA_SIZE, /**< the minimum number of bits for the alpha channel of the color buffer; defaults to 0. */
SDL_GL_BUFFER_SIZE, /**< the minimum number of bits for frame buffer size; defaults to 0. */
SDL_GL_DOUBLEBUFFER, /**< whether the output is single or double buffered; defaults to double buffering on. */
SDL_GL_DEPTH_SIZE, /**< the minimum number of bits in the depth buffer; defaults to 16. */
SDL_GL_STENCIL_SIZE, /**< the minimum number of bits in the stencil buffer; defaults to 0. */
SDL_GL_ACCUM_RED_SIZE, /**< the minimum number of bits for the red channel of the accumulation buffer; defaults to 0. */
SDL_GL_ACCUM_GREEN_SIZE, /**< the minimum number of bits for the green channel of the accumulation buffer; defaults to 0. */
SDL_GL_ACCUM_BLUE_SIZE, /**< the minimum number of bits for the blue channel of the accumulation buffer; defaults to 0. */
SDL_GL_ACCUM_ALPHA_SIZE, /**< the minimum number of bits for the alpha channel of the accumulation buffer; defaults to 0. */
SDL_GL_STEREO, /**< whether the output is stereo 3D; defaults to off. */
SDL_GL_MULTISAMPLEBUFFERS, /**< the number of buffers used for multisample anti-aliasing; defaults to 0. */
SDL_GL_MULTISAMPLESAMPLES, /**< the number of samples used around the current pixel used for multisample anti-aliasing. */
SDL_GL_ACCELERATED_VISUAL, /**< set to 1 to require hardware acceleration, set to 0 to force software rendering; defaults to allow either. */
SDL_GL_RETAINED_BACKING, /**< not used (deprecated). */
SDL_GL_CONTEXT_MAJOR_VERSION, /**< OpenGL context major version. */
SDL_GL_CONTEXT_MINOR_VERSION, /**< OpenGL context minor version. */
SDL_GL_CONTEXT_EGL, /**< deprecated: set SDL_GL_CONTEXT_PROFILE_MASK to SDL_GL_CONTEXT_PROFILE_ES to enable instead. */
SDL_GL_CONTEXT_FLAGS, /**< some combination of 0 or more of elements of the SDL_GLcontextFlag enumeration; defaults to 0. */
SDL_GL_CONTEXT_PROFILE_MASK, /**< type of GL context (Core, Compatibility, ES). See SDL_GLprofile; default value depends on platform. */
SDL_GL_SHARE_WITH_CURRENT_CONTEXT, /**< OpenGL context sharing; defaults to 0. */
SDL_GL_FRAMEBUFFER_SRGB_CAPABLE, /**< requests sRGB capable visual; defaults to 0. (>= SDL 2.0.1) */
SDL_GL_CONTEXT_RELEASE_BEHAVIOR, /**< sets context the release behavior; defaults to 1. (>= SDL 2.0.4) */
SDL_GL_CONTEXT_RESET_NOTIFICATION,
SDL_GL_CONTEXT_NO_ERROR,
SDL_GL_FLOATBUFFERS
} SDL_GLattr;
SDL_GLattr
SDL_GLattr
Definition SDL_video.h:257
SDL_GL_FRAMEBUFFER_SRGB_CAPABLE
@ SDL_GL_FRAMEBUFFER_SRGB_CAPABLE
Definition SDL_video.h:281
SDL_GL_CONTEXT_RELEASE_BEHAVIOR
@ SDL_GL_CONTEXT_RELEASE_BEHAVIOR
Definition SDL_video.h:282
SDL_GL_DOUBLEBUFFER
@ SDL_GL_DOUBLEBUFFER
Definition SDL_video.h:263
SDL_GL_STENCIL_SIZE
@ SDL_GL_STENCIL_SIZE
Definition SDL_video.h:265
SDL_GL_CONTEXT_MAJOR_VERSION
@ SDL_GL_CONTEXT_MAJOR_VERSION
Definition SDL_video.h:275
SDL_GL_CONTEXT_RESET_NOTIFICATION
@ SDL_GL_CONTEXT_RESET_NOTIFICATION
Definition SDL_video.h:283
SDL_GL_CONTEXT_EGL
@ SDL_GL_CONTEXT_EGL
Definition SDL_video.h:277
SDL_GL_ACCUM_ALPHA_SIZE
@ SDL_GL_ACCUM_ALPHA_SIZE
Definition SDL_video.h:269
SDL_GL_MULTISAMPLESAMPLES
@ SDL_GL_MULTISAMPLESAMPLES
Definition SDL_video.h:272
SDL_GL_CONTEXT_MINOR_VERSION
@ SDL_GL_CONTEXT_MINOR_VERSION
Definition SDL_video.h:276
SDL_GL_FLOATBUFFERS
@ SDL_GL_FLOATBUFFERS
Definition SDL_video.h:285
SDL_GL_STEREO
@ SDL_GL_STEREO
Definition SDL_video.h:270
SDL_GL_MULTISAMPLEBUFFERS
@ SDL_GL_MULTISAMPLEBUFFERS
Definition SDL_video.h:271
SDL_GL_ACCUM_GREEN_SIZE
@ SDL_GL_ACCUM_GREEN_SIZE
Definition SDL_video.h:267
SDL_GL_BLUE_SIZE
@ SDL_GL_BLUE_SIZE
Definition SDL_video.h:260
SDL_GL_SHARE_WITH_CURRENT_CONTEXT
@ SDL_GL_SHARE_WITH_CURRENT_CONTEXT
Definition SDL_video.h:280
SDL_GL_RETAINED_BACKING
@ SDL_GL_RETAINED_BACKING
Definition SDL_video.h:274
SDL_GL_RED_SIZE
@ SDL_GL_RED_SIZE
Definition SDL_video.h:258
SDL_GL_ALPHA_SIZE
@ SDL_GL_ALPHA_SIZE
Definition SDL_video.h:261
SDL_GL_BUFFER_SIZE
@ SDL_GL_BUFFER_SIZE
Definition SDL_video.h:262
SDL_GL_ACCELERATED_VISUAL
@ SDL_GL_ACCELERATED_VISUAL
Definition SDL_video.h:273
SDL_GL_ACCUM_BLUE_SIZE
@ SDL_GL_ACCUM_BLUE_SIZE
Definition SDL_video.h:268
SDL_GL_DEPTH_SIZE
@ SDL_GL_DEPTH_SIZE
Definition SDL_video.h:264
SDL_GL_ACCUM_RED_SIZE
@ SDL_GL_ACCUM_RED_SIZE
Definition SDL_video.h:266
SDL_GL_CONTEXT_FLAGS
@ SDL_GL_CONTEXT_FLAGS
Definition SDL_video.h:278
SDL_GL_CONTEXT_PROFILE_MASK
@ SDL_GL_CONTEXT_PROFILE_MASK
Definition SDL_video.h:279
SDL_GL_CONTEXT_NO_ERROR
@ SDL_GL_CONTEXT_NO_ERROR
Definition SDL_video.h:284
SDL_GL_GREEN_SIZE
@ SDL_GL_GREEN_SIZE
Definition SDL_video.h:259

## SDL_GLcontextFlag

enum SDL_GLcontextFlag

Enumerator
SDL_GL_CONTEXT_DEBUG_FLAG |
SDL_GL_CONTEXT_FORWARD_COMPATIBLE_FLAG |
SDL_GL_CONTEXT_ROBUST_ACCESS_FLAG |
SDL_GL_CONTEXT_RESET_ISOLATION_FLAG |

Definition at line 295 of file SDL_video.h.

{
SDL_GL_CONTEXT_DEBUG_FLAG = 0x0001,
SDL_GL_CONTEXT_FORWARD_COMPATIBLE_FLAG = 0x0002,
SDL_GL_CONTEXT_ROBUST_ACCESS_FLAG = 0x0004,
SDL_GL_CONTEXT_RESET_ISOLATION_FLAG = 0x0008
} SDL_GLcontextFlag;
SDL_GLcontextFlag
SDL_GLcontextFlag
Definition SDL_video.h:296
SDL_GL_CONTEXT_FORWARD_COMPATIBLE_FLAG
@ SDL_GL_CONTEXT_FORWARD_COMPATIBLE_FLAG
Definition SDL_video.h:298
SDL_GL_CONTEXT_RESET_ISOLATION_FLAG
@ SDL_GL_CONTEXT_RESET_ISOLATION_FLAG
Definition SDL_video.h:300
SDL_GL_CONTEXT_ROBUST_ACCESS_FLAG
@ SDL_GL_CONTEXT_ROBUST_ACCESS_FLAG
Definition SDL_video.h:299
SDL_GL_CONTEXT_DEBUG_FLAG
@ SDL_GL_CONTEXT_DEBUG_FLAG
Definition SDL_video.h:297

## SDL_GLcontextReleaseFlag

enum SDL_GLcontextReleaseFlag

Enumerator
SDL_GL_CONTEXT_RELEASE_BEHAVIOR_NONE |
SDL_GL_CONTEXT_RELEASE_BEHAVIOR_FLUSH |

Definition at line 303 of file SDL_video.h.

{
SDL_GL_CONTEXT_RELEASE_BEHAVIOR_NONE = 0x0000,
SDL_GL_CONTEXT_RELEASE_BEHAVIOR_FLUSH = 0x0001
} SDL_GLcontextReleaseFlag;
SDL_GLcontextReleaseFlag
SDL_GLcontextReleaseFlag
Definition SDL_video.h:304
SDL_GL_CONTEXT_RELEASE_BEHAVIOR_NONE
@ SDL_GL_CONTEXT_RELEASE_BEHAVIOR_NONE
Definition SDL_video.h:305
SDL_GL_CONTEXT_RELEASE_BEHAVIOR_FLUSH
@ SDL_GL_CONTEXT_RELEASE_BEHAVIOR_FLUSH
Definition SDL_video.h:306

## SDL_GLContextResetNotification

enum SDL_GLContextResetNotification

Enumerator
SDL_GL_CONTEXT_RESET_NO_NOTIFICATION |
SDL_GL_CONTEXT_RESET_LOSE_CONTEXT |

Definition at line 309 of file SDL_video.h.

{
SDL_GL_CONTEXT_RESET_NO_NOTIFICATION = 0x0000,
SDL_GL_CONTEXT_RESET_LOSE_CONTEXT = 0x0001
} SDL_GLContextResetNotification;
SDL_GLContextResetNotification
SDL_GLContextResetNotification
Definition SDL_video.h:310
SDL_GL_CONTEXT_RESET_NO_NOTIFICATION
@ SDL_GL_CONTEXT_RESET_NO_NOTIFICATION
Definition SDL_video.h:311
SDL_GL_CONTEXT_RESET_LOSE_CONTEXT
@ SDL_GL_CONTEXT_RESET_LOSE_CONTEXT
Definition SDL_video.h:312

## SDL_GLprofile

enum SDL_GLprofile

Enumerator
SDL_GL_CONTEXT_PROFILE_CORE |
SDL_GL_CONTEXT_PROFILE_COMPATIBILITY |
SDL_GL_CONTEXT_PROFILE_ES | GLX_CONTEXT_ES2_PROFILE_BIT_EXT

Definition at line 288 of file SDL_video.h.

{
SDL_GL_CONTEXT_PROFILE_CORE = 0x0001,
SDL_GL_CONTEXT_PROFILE_COMPATIBILITY = 0x0002,
SDL_GL_CONTEXT_PROFILE_ES = 0x0004 /**< GLX_CONTEXT_ES2_PROFILE_BIT_EXT */
} SDL_GLprofile;
SDL_GLprofile
SDL_GLprofile
Definition SDL_video.h:289
SDL_GL_CONTEXT_PROFILE_COMPATIBILITY
@ SDL_GL_CONTEXT_PROFILE_COMPATIBILITY
Definition SDL_video.h:291
SDL_GL_CONTEXT_PROFILE_ES
@ SDL_GL_CONTEXT_PROFILE_ES
Definition SDL_video.h:292
SDL_GL_CONTEXT_PROFILE_CORE
@ SDL_GL_CONTEXT_PROFILE_CORE
Definition SDL_video.h:290

## SDL_HitTestResult

enum SDL_HitTestResult

Possible return values from the SDL_HitTest callback.

See also
  SDL_HitTest

Enumerator
SDL_HITTEST_NORMAL | Region is normal. No special properties.
SDL_HITTEST_DRAGGABLE | Region can drag entire window.
SDL_HITTEST_RESIZE_TOPLEFT |
SDL_HITTEST_RESIZE_TOP |
SDL_HITTEST_RESIZE_TOPRIGHT |
SDL_HITTEST_RESIZE_RIGHT |
SDL_HITTEST_RESIZE_BOTTOMRIGHT |
SDL_HITTEST_RESIZE_BOTTOM |
SDL_HITTEST_RESIZE_BOTTOMLEFT |
SDL_HITTEST_RESIZE_LEFT |

Definition at line 1755 of file SDL_video.h.

{
SDL_HITTEST_NORMAL, /**< Region is normal. No special properties. */
SDL_HITTEST_DRAGGABLE, /**< Region can drag entire window. */
SDL_HITTEST_RESIZE_TOPLEFT,
SDL_HITTEST_RESIZE_TOP,
SDL_HITTEST_RESIZE_TOPRIGHT,
SDL_HITTEST_RESIZE_RIGHT,
SDL_HITTEST_RESIZE_BOTTOMRIGHT,
SDL_HITTEST_RESIZE_BOTTOM,
SDL_HITTEST_RESIZE_BOTTOMLEFT,
SDL_HITTEST_RESIZE_LEFT
} SDL_HitTestResult;
SDL_HitTestResult
SDL_HitTestResult
Definition SDL_video.h:1756
SDL_HITTEST_DRAGGABLE
@ SDL_HITTEST_DRAGGABLE
Definition SDL_video.h:1758
SDL_HITTEST_RESIZE_LEFT
@ SDL_HITTEST_RESIZE_LEFT
Definition SDL_video.h:1766
SDL_HITTEST_RESIZE_TOP
@ SDL_HITTEST_RESIZE_TOP
Definition SDL_video.h:1760
SDL_HITTEST_RESIZE_TOPRIGHT
@ SDL_HITTEST_RESIZE_TOPRIGHT
Definition SDL_video.h:1761
SDL_HITTEST_NORMAL
@ SDL_HITTEST_NORMAL
Definition SDL_video.h:1757
SDL_HITTEST_RESIZE_BOTTOM
@ SDL_HITTEST_RESIZE_BOTTOM
Definition SDL_video.h:1764
SDL_HITTEST_RESIZE_BOTTOMRIGHT
@ SDL_HITTEST_RESIZE_BOTTOMRIGHT
Definition SDL_video.h:1763
SDL_HITTEST_RESIZE_BOTTOMLEFT
@ SDL_HITTEST_RESIZE_BOTTOMLEFT
Definition SDL_video.h:1765
SDL_HITTEST_RESIZE_RIGHT
@ SDL_HITTEST_RESIZE_RIGHT
Definition SDL_video.h:1762
SDL_HITTEST_RESIZE_TOPLEFT
@ SDL_HITTEST_RESIZE_TOPLEFT
Definition SDL_video.h:1759

## SDL_WindowEventID

enum SDL_WindowEventID

Event subtype for window events

Enumerator
SDL_WINDOWEVENT_NONE | Never used
SDL_WINDOWEVENT_SHOWN | Window has been shown
SDL_WINDOWEVENT_HIDDEN | Window has been hidden
SDL_WINDOWEVENT_EXPOSED | Window has been exposed and should be redrawn
SDL_WINDOWEVENT_MOVED | Window has been moved to data1, data2
SDL_WINDOWEVENT_RESIZED | Window has been resized to data1xdata2
SDL_WINDOWEVENT_SIZE_CHANGED | The window size has changed, either as a result of an API call or through the system or user changing the window size.
SDL_WINDOWEVENT_MINIMIZED | Window has been minimized
SDL_WINDOWEVENT_MAXIMIZED | Window has been maximized
SDL_WINDOWEVENT_RESTORED | Window has been restored to normal size and position
SDL_WINDOWEVENT_ENTER | Window has gained mouse focus
SDL_WINDOWEVENT_LEAVE | Window has lost mouse focus
SDL_WINDOWEVENT_FOCUS_GAINED | Window has gained keyboard focus
SDL_WINDOWEVENT_FOCUS_LOST | Window has lost keyboard focus
SDL_WINDOWEVENT_CLOSE | The window manager requests that the window be closed
SDL_WINDOWEVENT_TAKE_FOCUS | Window is being offered a focus (should SetWindowInputFocus() on itself or a subwindow, or ignore)
SDL_WINDOWEVENT_HIT_TEST | Window had a hit test that wasn't SDL_HITTEST_NORMAL.
SDL_WINDOWEVENT_ICCPROF_CHANGED | The ICC profile of the window's display has changed.
SDL_WINDOWEVENT_DISPLAY_CHANGED | Window has been moved to display data1.

Definition at line 154 of file SDL_video.h.

{
SDL_WINDOWEVENT_NONE, /**< Never used */
SDL_WINDOWEVENT_SHOWN, /**< Window has been shown */
SDL_WINDOWEVENT_HIDDEN, /**< Window has been hidden */
SDL_WINDOWEVENT_EXPOSED, /**< Window has been exposed and should be
redrawn */
SDL_WINDOWEVENT_MOVED, /**< Window has been moved to data1, data2
*/
SDL_WINDOWEVENT_RESIZED, /**< Window has been resized to data1xdata2 */
SDL_WINDOWEVENT_SIZE_CHANGED, /**< The window size has changed, either as
a result of an API call or through the
system or user changing the window size. */
SDL_WINDOWEVENT_MINIMIZED, /**< Window has been minimized */
SDL_WINDOWEVENT_MAXIMIZED, /**< Window has been maximized */
SDL_WINDOWEVENT_RESTORED, /**< Window has been restored to normal size
and position */
SDL_WINDOWEVENT_ENTER, /**< Window has gained mouse focus */
SDL_WINDOWEVENT_LEAVE, /**< Window has lost mouse focus */
SDL_WINDOWEVENT_FOCUS_GAINED, /**< Window has gained keyboard focus */
SDL_WINDOWEVENT_FOCUS_LOST, /**< Window has lost keyboard focus */
SDL_WINDOWEVENT_CLOSE, /**< The window manager requests that the window be closed */
SDL_WINDOWEVENT_TAKE_FOCUS, /**< Window is being offered a focus (should SetWindowInputFocus() on itself or a subwindow, or ignore) */
SDL_WINDOWEVENT_HIT_TEST, /**< Window had a hit test that wasn't SDL_HITTEST_NORMAL. */
SDL_WINDOWEVENT_ICCPROF_CHANGED,/**< The ICC profile of the window's display has changed. */
SDL_WINDOWEVENT_DISPLAY_CHANGED /**< Window has been moved to display data1. */
} SDL_WindowEventID;
SDL_WindowEventID
SDL_WindowEventID
Definition SDL_video.h:155
SDL_WINDOWEVENT_HIDDEN
@ SDL_WINDOWEVENT_HIDDEN
Definition SDL_video.h:158
SDL_WINDOWEVENT_FOCUS_LOST
@ SDL_WINDOWEVENT_FOCUS_LOST
Definition SDL_video.h:174
SDL_WINDOWEVENT_CLOSE
@ SDL_WINDOWEVENT_CLOSE
Definition SDL_video.h:175
SDL_WINDOWEVENT_RESIZED
@ SDL_WINDOWEVENT_RESIZED
Definition SDL_video.h:163
SDL_WINDOWEVENT_HIT_TEST
@ SDL_WINDOWEVENT_HIT_TEST
Definition SDL_video.h:177
SDL_WINDOWEVENT_FOCUS_GAINED
@ SDL_WINDOWEVENT_FOCUS_GAINED
Definition SDL_video.h:173
SDL_WINDOWEVENT_SHOWN
@ SDL_WINDOWEVENT_SHOWN
Definition SDL_video.h:157
SDL_WINDOWEVENT_MOVED
@ SDL_WINDOWEVENT_MOVED
Definition SDL_video.h:161
SDL_WINDOWEVENT_TAKE_FOCUS
@ SDL_WINDOWEVENT_TAKE_FOCUS
Definition SDL_video.h:176
SDL_WINDOWEVENT_MINIMIZED
@ SDL_WINDOWEVENT_MINIMIZED
Definition SDL_video.h:167
SDL_WINDOWEVENT_DISPLAY_CHANGED
@ SDL_WINDOWEVENT_DISPLAY_CHANGED
Definition SDL_video.h:179
SDL_WINDOWEVENT_LEAVE
@ SDL_WINDOWEVENT_LEAVE
Definition SDL_video.h:172
SDL_WINDOWEVENT_MAXIMIZED
@ SDL_WINDOWEVENT_MAXIMIZED
Definition SDL_video.h:168
SDL_WINDOWEVENT_SIZE_CHANGED
@ SDL_WINDOWEVENT_SIZE_CHANGED
Definition SDL_video.h:164
SDL_WINDOWEVENT_RESTORED
@ SDL_WINDOWEVENT_RESTORED
Definition SDL_video.h:169
SDL_WINDOWEVENT_ICCPROF_CHANGED
@ SDL_WINDOWEVENT_ICCPROF_CHANGED
Definition SDL_video.h:178
SDL_WINDOWEVENT_EXPOSED
@ SDL_WINDOWEVENT_EXPOSED
Definition SDL_video.h:159
SDL_WINDOWEVENT_ENTER
@ SDL_WINDOWEVENT_ENTER
Definition SDL_video.h:171
SDL_WINDOWEVENT_NONE
@ SDL_WINDOWEVENT_NONE
Definition SDL_video.h:156

## SDL_WindowFlags

enum SDL_WindowFlags

The flags on a window

See also
  SDL_GetWindowFlags

Enumerator
SDL_WINDOW_FULLSCREEN | fullscreen window
SDL_WINDOW_OPENGL | window usable with OpenGL context
SDL_WINDOW_SHOWN | window is visible
SDL_WINDOW_HIDDEN | window is not visible
SDL_WINDOW_BORDERLESS | no window decoration
SDL_WINDOW_RESIZABLE | window can be resized
SDL_WINDOW_MINIMIZED | window is minimized
SDL_WINDOW_MAXIMIZED | window is maximized
SDL_WINDOW_MOUSE_GRABBED | window has grabbed mouse input
SDL_WINDOW_INPUT_FOCUS | window has input focus
SDL_WINDOW_MOUSE_FOCUS | window has mouse focus
SDL_WINDOW_FULLSCREEN_DESKTOP |
SDL_WINDOW_FOREIGN | window not created by SDL
SDL_WINDOW_ALLOW_HIGHDPI | window should be created in high-DPI mode if supported. On macOS NSHighResolutionCapable must be set true in the application's Info.plist for this to have any effect.
SDL_WINDOW_MOUSE_CAPTURE | window has mouse captured (unrelated to MOUSE_GRABBED)
SDL_WINDOW_ALWAYS_ON_TOP | window should always be above others
SDL_WINDOW_SKIP_TASKBAR | window should not be added to the taskbar
SDL_WINDOW_UTILITY | window should be treated as a utility window
SDL_WINDOW_TOOLTIP | window should be treated as a tooltip
SDL_WINDOW_POPUP_MENU | window should be treated as a popup menu
SDL_WINDOW_KEYBOARD_GRABBED | window has grabbed keyboard input
SDL_WINDOW_VULKAN | window usable for Vulkan surface
SDL_WINDOW_METAL | window usable for Metal view
SDL_WINDOW_INPUT_GRABBED | equivalent to SDL_WINDOW_MOUSE_GRABBED for compatibility

Definition at line 102 of file SDL_video.h.

{
SDL_WINDOW_FULLSCREEN = 0x00000001, /**< fullscreen window */
SDL_WINDOW_OPENGL = 0x00000002, /**< window usable with OpenGL context */
SDL_WINDOW_SHOWN = 0x00000004, /**< window is visible */
SDL_WINDOW_HIDDEN = 0x00000008, /**< window is not visible */
SDL_WINDOW_BORDERLESS = 0x00000010, /**< no window decoration */
SDL_WINDOW_RESIZABLE = 0x00000020, /**< window can be resized */
SDL_WINDOW_MINIMIZED = 0x00000040, /**< window is minimized */
SDL_WINDOW_MAXIMIZED = 0x00000080, /**< window is maximized */
SDL_WINDOW_MOUSE_GRABBED = 0x00000100, /**< window has grabbed mouse input */
SDL_WINDOW_INPUT_FOCUS = 0x00000200, /**< window has input focus */
SDL_WINDOW_MOUSE_FOCUS = 0x00000400, /**< window has mouse focus */
SDL_WINDOW_FULLSCREEN_DESKTOP = ( SDL_WINDOW_FULLSCREEN | 0x00001000 ),
SDL_WINDOW_FOREIGN = 0x00000800, /**< window not created by SDL */
SDL_WINDOW_ALLOW_HIGHDPI = 0x00002000, /**< window should be created in high-DPI mode if supported.
On macOS NSHighResolutionCapable must be set true in the
application's Info.plist for this to have any effect. */
SDL_WINDOW_MOUSE_CAPTURE = 0x00004000, /**< window has mouse captured (unrelated to MOUSE_GRABBED) */
SDL_WINDOW_ALWAYS_ON_TOP = 0x00008000, /**< window should always be above others */
SDL_WINDOW_SKIP_TASKBAR = 0x00010000, /**< window should not be added to the taskbar */
SDL_WINDOW_UTILITY = 0x00020000, /**< window should be treated as a utility window */
SDL_WINDOW_TOOLTIP = 0x00040000, /**< window should be treated as a tooltip */
SDL_WINDOW_POPUP_MENU = 0x00080000, /**< window should be treated as a popup menu */
SDL_WINDOW_KEYBOARD_GRABBED = 0x00100000, /**< window has grabbed keyboard input */
SDL_WINDOW_VULKAN = 0x10000000, /**< window usable for Vulkan surface */
SDL_WINDOW_METAL = 0x20000000, /**< window usable for Metal view */
SDL_WINDOW_INPUT_GRABBED = SDL_WINDOW_MOUSE_GRABBED /**< equivalent to SDL_WINDOW_MOUSE_GRABBED for compatibility */
} SDL_WindowFlags;
SDL_WindowFlags
SDL_WindowFlags
Definition SDL_video.h:103
SDL_WINDOW_ALLOW_HIGHDPI
@ SDL_WINDOW_ALLOW_HIGHDPI
Definition SDL_video.h:117
SDL_WINDOW_FOREIGN
@ SDL_WINDOW_FOREIGN
Definition SDL_video.h:116
SDL_WINDOW_TOOLTIP
@ SDL_WINDOW_TOOLTIP
Definition SDL_video.h:124
SDL_WINDOW_ALWAYS_ON_TOP
@ SDL_WINDOW_ALWAYS_ON_TOP
Definition SDL_video.h:121
SDL_WINDOW_SHOWN
@ SDL_WINDOW_SHOWN
Definition SDL_video.h:106
SDL_WINDOW_SKIP_TASKBAR
@ SDL_WINDOW_SKIP_TASKBAR
Definition SDL_video.h:122
SDL_WINDOW_MOUSE_CAPTURE
@ SDL_WINDOW_MOUSE_CAPTURE
Definition SDL_video.h:120
SDL_WINDOW_VULKAN
@ SDL_WINDOW_VULKAN
Definition SDL_video.h:127
SDL_WINDOW_OPENGL
@ SDL_WINDOW_OPENGL
Definition SDL_video.h:105
SDL_WINDOW_MINIMIZED
@ SDL_WINDOW_MINIMIZED
Definition SDL_video.h:110
SDL_WINDOW_UTILITY
@ SDL_WINDOW_UTILITY
Definition SDL_video.h:123
SDL_WINDOW_MOUSE_FOCUS
@ SDL_WINDOW_MOUSE_FOCUS
Definition SDL_video.h:114
SDL_WINDOW_INPUT_GRABBED
@ SDL_WINDOW_INPUT_GRABBED
Definition SDL_video.h:130
SDL_WINDOW_RESIZABLE
@ SDL_WINDOW_RESIZABLE
Definition SDL_video.h:109
SDL_WINDOW_KEYBOARD_GRABBED
@ SDL_WINDOW_KEYBOARD_GRABBED
Definition SDL_video.h:126
SDL_WINDOW_FULLSCREEN_DESKTOP
@ SDL_WINDOW_FULLSCREEN_DESKTOP
Definition SDL_video.h:115
SDL_WINDOW_FULLSCREEN
@ SDL_WINDOW_FULLSCREEN
Definition SDL_video.h:104
SDL_WINDOW_MAXIMIZED
@ SDL_WINDOW_MAXIMIZED
Definition SDL_video.h:111
SDL_WINDOW_METAL
@ SDL_WINDOW_METAL
Definition SDL_video.h:128
SDL_WINDOW_HIDDEN
@ SDL_WINDOW_HIDDEN
Definition SDL_video.h:107
SDL_WINDOW_MOUSE_GRABBED
@ SDL_WINDOW_MOUSE_GRABBED
Definition SDL_video.h:112
SDL_WINDOW_POPUP_MENU
@ SDL_WINDOW_POPUP_MENU
Definition SDL_video.h:125
SDL_WINDOW_BORDERLESS
@ SDL_WINDOW_BORDERLESS
Definition SDL_video.h:108
SDL_WINDOW_INPUT_FOCUS
@ SDL_WINDOW_INPUT_FOCUS
Definition SDL_video.h:113

## Function Documentation

## SDL_CreateWindow()

SDL_Window * SDL_CreateWindow | ( | const char * | title,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | Uint32 | flags )

extern

Create a window with the specified position, dimensions, and flags.

flags may be any of the following OR'd together:

- SDL_WINDOW_FULLSCREEN: fullscreen window
- SDL_WINDOW_FULLSCREEN_DESKTOP: fullscreen window at desktop resolution
- SDL_WINDOW_OPENGL: window usable with an OpenGL context
- SDL_WINDOW_VULKAN: window usable with a Vulkan instance
- SDL_WINDOW_METAL: window usable with a Metal instance
- SDL_WINDOW_HIDDEN: window is not visible
- SDL_WINDOW_BORDERLESS: no window decoration
- SDL_WINDOW_RESIZABLE: window can be resized
- SDL_WINDOW_MINIMIZED: window is minimized
- SDL_WINDOW_MAXIMIZED: window is maximized
- SDL_WINDOW_INPUT_GRABBED: window has grabbed input focus
- SDL_WINDOW_ALLOW_HIGHDPI: window should be created in high-DPI mode if supported (>= SDL 2.0.1)

SDL_WINDOW_SHOWN is ignored by SDL_CreateWindow(). The SDL_Window is implicitly shown if SDL_WINDOW_HIDDEN is not set. SDL_WINDOW_SHOWN may be queried later using SDL_GetWindowFlags().

On Apple's macOS, you must set the NSHighResolutionCapable Info.plist property to YES, otherwise you will not receive a High-DPI OpenGL canvas.

If the window is created with the SDL_WINDOW_ALLOW_HIGHDPI flag, its size in pixels may differ from its size in screen coordinates on platforms with high-DPI support (e.g. iOS and macOS). Use SDL_GetWindowSize() to query the client area's size in screen coordinates, and SDL_GL_GetDrawableSize() or SDL_GetRendererOutputSize() to query the drawable size in pixels. Note that when this flag is set, the drawable size can vary after the window is created and should be queried after major window events such as when the window is resized or moved between displays.

If the window is set fullscreen, the width and height parameters w and h will not be used. However, invalid size parameters (e.g. too large) may still fail. Window size is actually limited to 16384 x 16384 for all platforms at window creation.

If the window is created with any of the SDL_WINDOW_OPENGL or SDL_WINDOW_VULKAN flags, then the corresponding LoadLibrary function (SDL_GL_LoadLibrary or SDL_Vulkan_LoadLibrary) is called and the corresponding UnloadLibrary function is called by SDL_DestroyWindow().

If SDL_WINDOW_VULKAN is specified and there isn't a working Vulkan driver, SDL_CreateWindow() will fail because SDL_Vulkan_LoadLibrary() will fail.

If SDL_WINDOW_METAL is specified on an OS that does not support Metal, SDL_CreateWindow() will fail.

On non-Apple devices, SDL requires you to either not link to the Vulkan loader or link to a dynamic library version. This limitation may be removed in a future version of SDL.

Parameters

  title | the title of the window, in UTF-8 encoding.
  x | the x position of the window, SDL_WINDOWPOS_CENTERED, or SDL_WINDOWPOS_UNDEFINED.
  y | the y position of the window, SDL_WINDOWPOS_CENTERED, or SDL_WINDOWPOS_UNDEFINED.
  w | the width of the window, in screen coordinates.
  h | the height of the window, in screen coordinates.
  flags | 0, or one or more SDL_WindowFlags OR'd together.

Returns
  the SDL_Window that was created or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateWindowFrom
  SDL_DestroyWindow

## SDL_CreateWindowFrom()

SDL_Window * SDL_CreateWindowFrom | ( | const void * | data | ) |

extern

Create an SDL window from an existing native window.

In some cases (e.g. OpenGL) and on some platforms (e.g. Microsoft Windows) the hint SDL_HINT_VIDEO_WINDOW_SHARE_PIXEL_FORMAT needs to be configured before using SDL_CreateWindowFrom().

Parameters

  data | a pointer to driver-dependent window creation data, typically your native window cast to a void*.

Returns
  the window that was created or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateWindow
  SDL_DestroyWindow

## SDL_DestroyWindow()

void SDL_DestroyWindow | ( | SDL_Window * | window | ) |

extern

Destroy a window.

If window is NULL, this function will return immediately after setting the SDL error message to "Invalid window". See SDL_GetError().

Parameters

  window | the window to destroy.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateWindow
  SDL_CreateWindowFrom

## SDL_DestroyWindowSurface()

int SDL_DestroyWindowSurface | ( | SDL_Window * | window | ) |

extern

Destroy the surface associated with the window.

Parameters

  window | the window to update.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.28.0.

See also
  SDL_GetWindowSurface
  SDL_HasWindowSurface

## SDL_DisableScreenSaver()

void SDL_DisableScreenSaver | ( | void |  | ) |

extern

Prevent the screen from being blanked by a screen saver.

If you disable the screensaver, it is automatically re-enabled when SDL quits.

The screensaver is disabled by default since SDL 2.0.2. Before SDL 2.0.2 the screensaver was enabled by default.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_EnableScreenSaver
  SDL_IsScreenSaverEnabled

## SDL_EnableScreenSaver()

void SDL_EnableScreenSaver | ( | void |  | ) |

extern

Allow the screen to be blanked by a screen saver.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_DisableScreenSaver
  SDL_IsScreenSaverEnabled

## SDL_FlashWindow()

int SDL_FlashWindow | ( | SDL_Window * | window,
|  | SDL_FlashOperation | operation )

extern

Request a window to demand attention from the user.

Parameters

  window | the window to be flashed.
  operation | the flash operation.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.16.

## SDL_GetClosestDisplayMode()

SDL_DisplayMode * SDL_GetClosestDisplayMode | ( | int | displayIndex,
|  | const SDL_DisplayMode * | mode,
|  | SDL_DisplayMode * | closest )

extern

Get the closest match to the requested display mode.

The available display modes are scanned and closest is filled in with the closest mode matching the requested mode and returned. The mode format and refresh rate default to the desktop mode if they are set to 0. The modes are scanned with size being first priority, format being second priority, and finally checking the refresh rate. If all the available modes are too small, then NULL is returned.

Parameters

  displayIndex | the index of the display to query.
  mode | an SDL_DisplayMode structure containing the desired display mode.
  closest | an SDL_DisplayMode structure filled in with the closest match of the available display modes.

Returns
  the passed in value closest or NULL if no matching video mode was available; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetDisplayMode
  SDL_GetNumDisplayModes

## SDL_GetCurrentDisplayMode()

int SDL_GetCurrentDisplayMode | ( | int | displayIndex,
|  | SDL_DisplayMode * | mode )

extern

Get information about the current display mode.

There's a difference between this function and SDL_GetDesktopDisplayMode() when SDL runs fullscreen and has changed the resolution. In that case this function will return the current display mode, and not the previous native display mode.

Parameters

  displayIndex | the index of the display to query.
  mode | an SDL_DisplayMode structure filled in with the current display mode.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetDesktopDisplayMode
  SDL_GetDisplayMode
  SDL_GetNumVideoDisplays
  SDL_SetWindowDisplayMode

## SDL_GetCurrentVideoDriver()

const char * SDL_GetCurrentVideoDriver | ( | void |  | ) |

extern

Get the name of the currently initialized video driver.

Returns
  the name of the current video driver or NULL if no driver has been initialized.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetNumVideoDrivers
  SDL_GetVideoDriver

## SDL_GetDesktopDisplayMode()

int SDL_GetDesktopDisplayMode | ( | int | displayIndex,
|  | SDL_DisplayMode * | mode )

extern

Get information about the desktop's display mode.

There's a difference between this function and SDL_GetCurrentDisplayMode() when SDL runs fullscreen and has changed the resolution. In that case this function will return the previous native display mode, and not the current display mode.

Parameters

  displayIndex | the index of the display to query.
  mode | an SDL_DisplayMode structure filled in with the current display mode.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetCurrentDisplayMode
  SDL_GetDisplayMode
  SDL_SetWindowDisplayMode

## SDL_GetDisplayBounds()

int SDL_GetDisplayBounds | ( | int | displayIndex,
|  | SDL_Rect * | rect )

extern

Get the desktop area represented by a display.

The primary display (displayIndex zero) is always located at 0,0.

Parameters

  displayIndex | the index of the display to query.
  rect | the SDL_Rect structure filled in with the display bounds.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetNumVideoDisplays

## SDL_GetDisplayDPI()

int SDL_GetDisplayDPI | ( | int | displayIndex,
|  | float * | ddpi,
|  | float * | hdpi,
|  | float * | vdpi )

extern

Get the dots/pixels-per-inch for a display.

Diagonal, horizontal and vertical DPI can all be optionally returned if the appropriate parameter is non-NULL.

A failure of this function usually means that either no DPI information is available or the displayIndex is out of range.

WARNING: This reports the DPI that the hardware reports, and it is not always reliable! It is almost always better to use SDL_GetWindowSize() to find the window size, which might be in logical points instead of pixels, and then SDL_GL_GetDrawableSize(), SDL_Vulkan_GetDrawableSize(), SDL_Metal_GetDrawableSize(), or SDL_GetRendererOutputSize(), and compare the two values to get an actual scaling value between the two. We will be rethinking how high-dpi details should be managed in SDL3 to make things more consistent, reliable, and clear.

Parameters

  displayIndex | the index of the display from which DPI information should be queried.
  ddpi | a pointer filled in with the diagonal DPI of the display; may be NULL.
  hdpi | a pointer filled in with the horizontal DPI of the display; may be NULL.
  vdpi | a pointer filled in with the vertical DPI of the display; may be NULL.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.4.

See also
  SDL_GetNumVideoDisplays

## SDL_GetDisplayMode()

int SDL_GetDisplayMode | ( | int | displayIndex,
|  | int | modeIndex,
|  | SDL_DisplayMode * | mode )

extern

Get information about a specific display mode.

The display modes are sorted in this priority:

- width -> largest to smallest
- height -> largest to smallest
- bits per pixel -> more colors to fewer colors
- packed pixel layout -> largest to smallest
- refresh rate -> highest to lowest

Parameters

  displayIndex | the index of the display to query.
  modeIndex | the index of the display mode to query.
  mode | an SDL_DisplayMode structure filled in with the mode at modeIndex.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetNumDisplayModes

## SDL_GetDisplayName()

const char * SDL_GetDisplayName | ( | int | displayIndex | ) |

extern

Get the name of a display in UTF-8 encoding.

Parameters

  displayIndex | the index of display from which the name should be queried.

Returns
  the name of a display or NULL for an invalid display index or failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetNumVideoDisplays

## SDL_GetDisplayOrientation()

SDL_DisplayOrientation SDL_GetDisplayOrientation | ( | int | displayIndex | ) |

extern

Get the orientation of a display.

Parameters

  displayIndex | the index of the display to query.

Returns
  The SDL_DisplayOrientation enum value of the display, or SDL_ORIENTATION_UNKNOWN if it isn't available.

Since
  This function is available since SDL 2.0.9.

See also
  SDL_GetNumVideoDisplays

## SDL_GetDisplayUsableBounds()

int SDL_GetDisplayUsableBounds | ( | int | displayIndex,
|  | SDL_Rect * | rect )

extern

Get the usable desktop area represented by a display.

The primary display (displayIndex zero) is always located at 0,0.

This is the same area as SDL_GetDisplayBounds() reports, but with portions reserved by the system removed. For example, on Apple's macOS, this subtracts the area occupied by the menu bar and dock.

Setting a window to be fullscreen generally bypasses these unusable areas, so these are good guidelines for the maximum space available to a non-fullscreen window.

The parameter rect is ignored if it is NULL.

This function also returns -1 if the parameter displayIndex is out of range.

Parameters

  displayIndex | the index of the display to query the usable bounds from.
  rect | the SDL_Rect structure filled in with the display bounds.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.5.

See also
  SDL_GetDisplayBounds
  SDL_GetNumVideoDisplays

## SDL_GetGrabbedWindow()

SDL_Window * SDL_GetGrabbedWindow | ( | void |  | ) |

extern

Get the window that currently has an input grab enabled.

Returns
  the window if input is grabbed or NULL otherwise.

Since
  This function is available since SDL 2.0.4.

See also
  SDL_GetWindowGrab
  SDL_SetWindowGrab

## SDL_GetNumDisplayModes()

int SDL_GetNumDisplayModes | ( | int | displayIndex | ) |

extern

Get the number of available display modes.

The displayIndex needs to be in the range from 0 to SDL_GetNumVideoDisplays() - 1.

Parameters

  displayIndex | the index of the display to query.

Returns
  a number >= 1 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetDisplayMode
  SDL_GetNumVideoDisplays

## SDL_GetNumVideoDisplays()

int SDL_GetNumVideoDisplays | ( | void |  | ) |

extern

Get the number of available video displays.

Returns
  a number >= 1 or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetDisplayBounds

## SDL_GetNumVideoDrivers()

int SDL_GetNumVideoDrivers | ( | void |  | ) |

extern

Get the number of video drivers compiled into SDL.

Returns
  a number >= 1 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetVideoDriver

## SDL_GetPointDisplayIndex()

int SDL_GetPointDisplayIndex | ( | const SDL_Point * | point | ) |

extern

Get the index of the display containing a point

Parameters

  point | the point to query.

Returns
  the index of the display containing the point or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.24.0.

See also
  SDL_GetDisplayBounds
  SDL_GetNumVideoDisplays

## SDL_GetRectDisplayIndex()

int SDL_GetRectDisplayIndex | ( | const SDL_Rect * | rect | ) |

extern

Get the index of the display primarily containing a rect

Parameters

  rect | the rect to query.

Returns
  the index of the display entirely containing the rect or closest to the center of the rect on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.24.0.

See also
  SDL_GetDisplayBounds
  SDL_GetNumVideoDisplays

## SDL_GetVideoDriver()

const char * SDL_GetVideoDriver | ( | int | index | ) |

extern

Get the name of a built in video driver.

The video drivers are presented in the order in which they are normally checked during initialization.

Parameters

  index | the index of a video driver.

Returns
  the name of the video driver with the given index.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetNumVideoDrivers

## SDL_GetWindowBordersSize()

int SDL_GetWindowBordersSize | ( | SDL_Window * | window,
|  | int * | top,
|  | int * | left,
|  | int * | bottom,
|  | int * | right )

extern

Get the size of a window's borders (decorations) around the client area.

Note: If this function fails (returns -1), the size values will be initialized to 0, 0, 0, 0 (if a non-NULL pointer is provided), as if the window in question was borderless.

Note: This function may fail on systems where the window has not yet been decorated by the display server (for example, immediately after calling SDL_CreateWindow). It is recommended that you wait at least until the window has been presented and composited, so that the window system has a chance to decorate the window and provide the border dimensions to SDL.

This function also returns -1 if getting the information is not supported.

Parameters

  window | the window to query the size values of the border (decorations) from.
  top | pointer to variable for storing the size of the top border; NULL is permitted.
  left | pointer to variable for storing the size of the left border; NULL is permitted.
  bottom | pointer to variable for storing the size of the bottom border; NULL is permitted.
  right | pointer to variable for storing the size of the right border; NULL is permitted.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.5.

See also
  SDL_GetWindowSize

## SDL_GetWindowBrightness()

float SDL_GetWindowBrightness | ( | SDL_Window * | window | ) |

extern

Get the brightness (gamma multiplier) for a given window's display.

Despite the name and signature, this method retrieves the brightness of the entire display, not an individual window. A window is considered to be owned by the display that contains the window's center pixel. (The index of this display can be retrieved using SDL_GetWindowDisplayIndex().)

Parameters

  window | the window used to select the display whose brightness will be queried.

Returns
  the brightness for the display where 0.0 is completely dark and 1.0 is normal brightness.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_SetWindowBrightness

## SDL_GetWindowData()

void * SDL_GetWindowData | ( | SDL_Window * | window,
|  | const char * | name )

extern

Retrieve the data pointer associated with a window.

Parameters

  window | the window to query.
  name | the name of the pointer.

Returns
  the value associated with name.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_SetWindowData

## SDL_GetWindowDisplayIndex()

int SDL_GetWindowDisplayIndex | ( | SDL_Window * | window | ) |

extern

Get the index of the display associated with a window.

Parameters

  window | the window to query.

Returns
  the index of the display containing the center of the window on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetDisplayBounds
  SDL_GetNumVideoDisplays

## SDL_GetWindowDisplayMode()

int SDL_GetWindowDisplayMode | ( | SDL_Window * | window,
|  | SDL_DisplayMode * | mode )

extern

Query the display mode to use when a window is visible at fullscreen.

Parameters

  window | the window to query.
  mode | an SDL_DisplayMode structure filled in with the fullscreen display mode.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_SetWindowDisplayMode
  SDL_SetWindowFullscreen

## SDL_GetWindowFlags()

Uint32 SDL_GetWindowFlags | ( | SDL_Window * | window | ) |

extern

Get the window flags.

Parameters

  window | the window to query.

Returns
  a mask of the SDL_WindowFlags associated with window.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateWindow
  SDL_HideWindow
  SDL_MaximizeWindow
  SDL_MinimizeWindow
  SDL_SetWindowFullscreen
  SDL_SetWindowGrab
  SDL_ShowWindow

## SDL_GetWindowFromID()

SDL_Window * SDL_GetWindowFromID | ( | Uint32 | id | ) |

extern

Get a window from a stored ID.

The numeric ID is what SDL_WindowEvent references, and is necessary to map these events to specific SDL_Window objects.

Parameters

  id | the ID of the window.

Returns
  the window associated with id or NULL if it doesn't exist; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowID

## SDL_GetWindowGammaRamp()

int SDL_GetWindowGammaRamp | ( | SDL_Window * | window,
|  | Uint16 * | red,
|  | Uint16 * | green,
|  | Uint16 * | blue )

extern

Get the gamma ramp for a given window's display.

Despite the name and signature, this method retrieves the gamma ramp of the entire display, not an individual window. A window is considered to be owned by the display that contains the window's center pixel. (The index of this display can be retrieved using SDL_GetWindowDisplayIndex().)

Parameters

  window | the window used to select the display whose gamma ramp will be queried.
  red | a 256 element array of 16-bit quantities filled in with the translation table for the red channel, or NULL.
  green | a 256 element array of 16-bit quantities filled in with the translation table for the green channel, or NULL.
  blue | a 256 element array of 16-bit quantities filled in with the translation table for the blue channel, or NULL.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_SetWindowGammaRamp

## SDL_GetWindowGrab()

SDL_bool SDL_GetWindowGrab | ( | SDL_Window * | window | ) |

extern

Get a window's input grab mode.

Parameters

  window | the window to query.

Returns
  SDL_TRUE if input is grabbed, SDL_FALSE otherwise.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_SetWindowGrab

## SDL_GetWindowICCProfile()

void * SDL_GetWindowICCProfile | ( | SDL_Window * | window,
|  | size_t * | size )

extern

Get the raw ICC profile data for the screen the window is currently on.

Data returned should be freed with SDL_free.

Parameters

  window | the window to query.
  size | the size of the ICC profile.

Returns
  the raw ICC profile data on success or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.18.

## SDL_GetWindowID()

Uint32 SDL_GetWindowID | ( | SDL_Window * | window | ) |

extern

Get the numeric ID of a window.

The numeric ID is what SDL_WindowEvent references, and is necessary to map these events to specific SDL_Window objects.

Parameters

  window | the window to query.

Returns
  the ID of the window on success or 0 on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowFromID

## SDL_GetWindowKeyboardGrab()

SDL_bool SDL_GetWindowKeyboardGrab | ( | SDL_Window * | window | ) |

extern

Get a window's keyboard grab mode.

Parameters

  window | the window to query.

Returns
  SDL_TRUE if keyboard is grabbed, and SDL_FALSE otherwise.

Since
  This function is available since SDL 2.0.16.

See also
  SDL_SetWindowKeyboardGrab
  SDL_GetWindowGrab

## SDL_GetWindowMaximumSize()

void SDL_GetWindowMaximumSize | ( | SDL_Window * | window,
|  | int * | w,
|  | int * | h )

extern

Get the maximum size of a window's client area.

Parameters

  window | the window to query.
  w | a pointer filled in with the maximum width of the window, may be NULL.
  h | a pointer filled in with the maximum height of the window, may be NULL.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowMinimumSize
  SDL_SetWindowMaximumSize

## SDL_GetWindowMinimumSize()

void SDL_GetWindowMinimumSize | ( | SDL_Window * | window,
|  | int * | w,
|  | int * | h )

extern

Get the minimum size of a window's client area.

Parameters

  window | the window to query.
  w | a pointer filled in with the minimum width of the window, may be NULL.
  h | a pointer filled in with the minimum height of the window, may be NULL.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowMaximumSize
  SDL_SetWindowMinimumSize

## SDL_GetWindowMouseGrab()

SDL_bool SDL_GetWindowMouseGrab | ( | SDL_Window * | window | ) |

extern

Get a window's mouse grab mode.

Parameters

  window | the window to query.

Returns
  SDL_TRUE if mouse is grabbed, and SDL_FALSE otherwise.

Since
  This function is available since SDL 2.0.16.

See also
  SDL_SetWindowKeyboardGrab
  SDL_GetWindowGrab

## SDL_GetWindowMouseRect()

const SDL_Rect * SDL_GetWindowMouseRect | ( | SDL_Window * | window | ) |

extern

Get the mouse confinement rectangle of a window.

Parameters

  window | The window to query.

Returns
  A pointer to the mouse confinement rectangle of a window, or NULL if there isn't one.

Since
  This function is available since SDL 2.0.18.

See also
  SDL_SetWindowMouseRect

## SDL_GetWindowOpacity()

int SDL_GetWindowOpacity | ( | SDL_Window * | window,
|  | float * | out_opacity )

extern

Get the opacity of a window.

If transparency isn't supported on this platform, opacity will be reported as 1.0f without error.

The parameter opacity is ignored if it is NULL.

This function also returns -1 if an invalid window was provided.

Parameters

  window | the window to get the current opacity value from.
  out_opacity | the float filled in (0.0f - transparent, 1.0f - opaque).

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.5.

See also
  SDL_SetWindowOpacity

## SDL_GetWindowPixelFormat()

Uint32 SDL_GetWindowPixelFormat | ( | SDL_Window * | window | ) |

extern

Get the pixel format associated with the window.

Parameters

  window | the window to query.

Returns
  the pixel format of the window on success or SDL_PIXELFORMAT_UNKNOWN on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

## SDL_GetWindowPosition()

void SDL_GetWindowPosition | ( | SDL_Window * | window,
|  | int * | x,
|  | int * | y )

extern

Get the position of a window.

If you do not need the value for one of the positions a NULL may be passed in the x or y parameter.

Parameters

  window | the window to query.
  x | a pointer filled in with the x position of the window, in screen coordinates, may be NULL.
  y | a pointer filled in with the y position of the window, in screen coordinates, may be NULL.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_SetWindowPosition

## SDL_GetWindowSize()

void SDL_GetWindowSize | ( | SDL_Window * | window,
|  | int * | w,
|  | int * | h )

extern

Get the size of a window's client area.

NULL can safely be passed as the w or h parameter if the width or height value is not desired.

The window size in screen coordinates may differ from the size in pixels, if the window was created with SDL_WINDOW_ALLOW_HIGHDPI on a platform with high-dpi support (e.g. iOS or macOS). Use SDL_GL_GetDrawableSize(), SDL_Vulkan_GetDrawableSize(), or SDL_GetRendererOutputSize() to get the real client area size in pixels.

Parameters

  window | the window to query the width and height from.
  w | a pointer filled in with the width of the window, in screen coordinates, may be NULL.
  h | a pointer filled in with the height of the window, in screen coordinates, may be NULL.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GL_GetDrawableSize
  SDL_Vulkan_GetDrawableSize
  SDL_SetWindowSize

## SDL_GetWindowSizeInPixels()

void SDL_GetWindowSizeInPixels | ( | SDL_Window * | window,
|  | int * | w,
|  | int * | h )

extern

Get the size of a window in pixels.

This may differ from SDL_GetWindowSize() if we're rendering to a high-DPI drawable, i.e. the window was created with SDL_WINDOW_ALLOW_HIGHDPI on a platform with high-DPI support (Apple calls this "Retina"), and not disabled by the SDL_HINT_VIDEO_HIGHDPI_DISABLED hint.

Parameters

  window | the window from which the drawable size should be queried.
  w | a pointer to variable for storing the width in pixels, may be NULL.
  h | a pointer to variable for storing the height in pixels, may be NULL.

Since
  This function is available since SDL 2.26.0.

See also
  SDL_CreateWindow
  SDL_GetWindowSize

## SDL_GetWindowSurface()

SDL_Surface * SDL_GetWindowSurface | ( | SDL_Window * | window | ) |

extern

Get the SDL surface associated with the window.

A new surface will be created with the optimal format for the window, if necessary. This surface will be freed when the window is destroyed. Do not free this surface.

This surface will be invalidated if the window is resized. After resizing a window this function must be called again to return a valid surface.

Note that on some platforms the pixels pointer of the surface may be modified after each call to SDL_UpdateWindowSurface(), so that the platform code can implement efficient double or triple buffering.

You may not combine this with 3D or the rendering API on this window.

This function is affected by SDL_HINT_FRAMEBUFFER_ACCELERATION.

Parameters

  window | the window to query.

Returns
  the surface associated with the window, or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_DestroyWindowSurface
  SDL_HasWindowSurface
  SDL_UpdateWindowSurface
  SDL_UpdateWindowSurfaceRects

## SDL_GetWindowTitle()

const char * SDL_GetWindowTitle | ( | SDL_Window * | window | ) |

extern

Get the title of a window.

Parameters

  window | the window to query.

Returns
  the title of the window in UTF-8 format or "" if there is no title.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_SetWindowTitle

## SDL_GL_CreateContext()

SDL_GLContext SDL_GL_CreateContext | ( | SDL_Window * | window | ) |

extern

Create an OpenGL context for an OpenGL window, and make it current.

Windows users new to OpenGL should note that, for historical reasons, GL functions added after OpenGL version 1.1 are not available by default. Those functions must be loaded at run-time, either with an OpenGL extension-handling library or with SDL_GL_GetProcAddress() and its related functions.

SDL_GLContext is an alias for void *. It's opaque to the application.

Parameters

  window | the window to associate with the context.

Returns
  the OpenGL context associated with window or NULL on error; call SDL_GetError() for more details.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GL_DeleteContext
  SDL_GL_MakeCurrent

## SDL_GL_DeleteContext()

void SDL_GL_DeleteContext | ( | SDL_GLContext | context | ) |

extern

Delete an OpenGL context.

Parameters

  context | the OpenGL context to be deleted.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GL_CreateContext

## SDL_GL_ExtensionSupported()

SDL_bool SDL_GL_ExtensionSupported | ( | const char * | extension | ) |

extern

Check if an OpenGL extension is supported for the current context.

This function operates on the current GL context; you must have created a context and it must be current before calling this function. Do not assume that all contexts you create will have the same set of extensions available, or that recreating an existing context will offer the same extensions again.

While it's probably not a massive overhead, this function is not an O(1) operation. Check the extensions you care about after creating the GL context and save that information somewhere instead of calling the function every time you need to know.

Parameters

  extension | the name of the extension to check.

Returns
  SDL_TRUE if the extension is supported, SDL_FALSE otherwise.

Since
  This function is available since SDL 2.0.0.

## SDL_GL_GetAttribute()

int SDL_GL_GetAttribute | ( | SDL_GLattr | attr,
|  | int * | value )

extern

Get the actual value for an attribute from the current context.

Parameters

  attr | an SDL_GLattr enum value specifying the OpenGL attribute to get.
  value | a pointer filled in with the current value of attr.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GL_ResetAttributes
  SDL_GL_SetAttribute

## SDL_GL_GetCurrentContext()

SDL_GLContext SDL_GL_GetCurrentContext | ( | void |  | ) |

extern

Get the currently active OpenGL context.

Returns
  the currently active OpenGL context or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GL_MakeCurrent

## SDL_GL_GetCurrentWindow()

SDL_Window * SDL_GL_GetCurrentWindow | ( | void |  | ) |

extern

Get the currently active OpenGL window.

Returns
  the currently active OpenGL window on success or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

## SDL_GL_GetDrawableSize()

void SDL_GL_GetDrawableSize | ( | SDL_Window * | window,
|  | int * | w,
|  | int * | h )

extern

Get the size of a window's underlying drawable in pixels.

This returns info useful for calling glViewport().

This may differ from SDL_GetWindowSize() if we're rendering to a high-DPI drawable, i.e. the window was created with SDL_WINDOW_ALLOW_HIGHDPI on a platform with high-DPI support (Apple calls this "Retina"), and not disabled by the SDL_HINT_VIDEO_HIGHDPI_DISABLED hint.

Parameters

  window | the window from which the drawable size should be queried.
  w | a pointer to variable for storing the width in pixels, may be NULL.
  h | a pointer to variable for storing the height in pixels, may be NULL.

Since
  This function is available since SDL 2.0.1.

See also
  SDL_CreateWindow
  SDL_GetWindowSize

## SDL_GL_GetProcAddress()

void * SDL_GL_GetProcAddress | ( | const char * | proc | ) |

extern

Get an OpenGL function by name.

If the GL library is loaded at runtime with SDL_GL_LoadLibrary(), then all GL functions must be retrieved this way. Usually this is used to retrieve function pointers to OpenGL extensions.

There are some quirks to looking up OpenGL functions that require some extra care from the application. If you code carefully, you can handle these quirks without any platform-specific code, though:

- On Windows, function pointers are specific to the current GL context; this means you need to have created a GL context and made it current before calling SDL_GL_GetProcAddress(). If you recreate your context or create a second context, you should assume that any existing function pointers aren't valid to use with it. This is (currently) a Windows-specific limitation, and in practice lots of drivers don't suffer this limitation, but it is still the way the wgl API is documented to work and you should expect crashes if you don't respect it. Store a copy of the function pointers that comes and goes with context lifespan.
- On X11, function pointers returned by this function are valid for any context, and can even be looked up before a context is created at all. This means that, for at least some common OpenGL implementations, if you look up a function that doesn't exist, you'll get a non-NULL result that is NOT safe to call. You must always make sure the function is actually available for a given GL context before calling it, by checking for the existence of the appropriate extension with SDL_GL_ExtensionSupported(), or verifying that the version of OpenGL you're using offers the function as core functionality.
- Some OpenGL drivers, on all platforms, will return NULL if a function isn't supported, but you can't count on this behavior. Check for extensions you use, and if you get a NULL anyway, act as if that extension wasn't available. This is probably a bug in the driver, but you can code defensively for this scenario anyhow.
- Just because you're on Linux/Unix, don't assume you'll be using X11. Next-gen display servers are waiting to replace it, and may or may not make the same promises about function pointers.
- OpenGL function pointers must be declared APIENTRY as in the example code. This will ensure the proper calling convention is followed on platforms where this matters (Win32) thereby avoiding stack corruption.

Parameters

  proc | the name of an OpenGL function.

Returns
  a pointer to the named OpenGL function. The returned pointer should be cast to the appropriate function signature.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GL_ExtensionSupported
  SDL_GL_LoadLibrary
  SDL_GL_UnloadLibrary

## SDL_GL_GetSwapInterval()

int SDL_GL_GetSwapInterval | ( | void |  | ) |

extern

Get the swap interval for the current OpenGL context.

If the system can't determine the swap interval, or there isn't a valid current context, this function will return 0 as a safe default.

Returns
  0 if there is no vertical retrace synchronization, 1 if the buffer swap is synchronized with the vertical retrace, and -1 if late swaps happen immediately instead of waiting for the next retrace; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GL_SetSwapInterval

## SDL_GL_LoadLibrary()

int SDL_GL_LoadLibrary | ( | const char * | path | ) |

extern

Dynamically load an OpenGL library.

This should be done after initializing the video driver, but before creating any OpenGL windows. If no OpenGL library is loaded, the default library will be loaded upon creation of the first OpenGL window.

If you do this, you need to retrieve all of the GL functions used in your program from the dynamic library using SDL_GL_GetProcAddress().

Parameters

  path | the platform dependent OpenGL library name, or NULL to open the default OpenGL library.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GL_GetProcAddress
  SDL_GL_UnloadLibrary

## SDL_GL_MakeCurrent()

int SDL_GL_MakeCurrent | ( | SDL_Window * | window,
|  | SDL_GLContext | context )

extern

Set up an OpenGL context for rendering into an OpenGL window.

The context must have been created with a compatible window.

Parameters

  window | the window to associate with the context.
  context | the OpenGL context to associate with the window.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GL_CreateContext

## SDL_GL_ResetAttributes()

void SDL_GL_ResetAttributes | ( | void |  | ) |

extern

Reset all previously set OpenGL context attributes to their default values.

Since
  This function is available since SDL 2.0.2.

See also
  SDL_GL_GetAttribute
  SDL_GL_SetAttribute

## SDL_GL_SetAttribute()

int SDL_GL_SetAttribute | ( | SDL_GLattr | attr,
|  | int | value )

extern

Set an OpenGL window attribute before window creation.

This function sets the OpenGL attribute attr to value. The requested attributes should be set before creating an OpenGL window. You should use SDL_GL_GetAttribute() to check the values after creating the OpenGL context, since the values obtained can differ from the requested ones.

Parameters

  attr | an SDL_GLattr enum value specifying the OpenGL attribute to set.
  value | the desired value for the attribute.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GL_GetAttribute
  SDL_GL_ResetAttributes

## SDL_GL_SetSwapInterval()

int SDL_GL_SetSwapInterval | ( | int | interval | ) |

extern

Set the swap interval for the current OpenGL context.

Some systems allow specifying -1 for the interval, to enable adaptive vsync. Adaptive vsync works the same as vsync, but if you've already missed the vertical retrace for a given frame, it swaps buffers immediately, which might be less jarring for the user during occasional framerate drops. If an application requests adaptive vsync and the system does not support it, this function will fail and return -1. In such a case, you should probably retry the call with 1 for the interval.

Adaptive vsync is implemented for some glX drivers with GLX_EXT_swap_control_tear, and for some Windows drivers with WGL_EXT_swap_control_tear.

Read more on the Khronos wiki: https://www.khronos.org/opengl/wiki/Swap_Interval#Adaptive_Vsync

Parameters

  interval | 0 for immediate updates, 1 for updates synchronized with the vertical retrace, -1 for adaptive vsync.

Returns
  0 on success or -1 if setting the swap interval is not supported; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GL_GetSwapInterval

## SDL_GL_SwapWindow()

void SDL_GL_SwapWindow | ( | SDL_Window * | window | ) |

extern

Update a window with OpenGL rendering.

This is used with double-buffered OpenGL contexts, which are the default.

On macOS, make sure you bind 0 to the draw framebuffer before swapping the window, otherwise nothing will happen. If you aren't using glBindFramebuffer(), this is the default and you won't have to do anything extra.

Parameters

  window | the window to change.

Since
  This function is available since SDL 2.0.0.

## SDL_GL_UnloadLibrary()

void SDL_GL_UnloadLibrary | ( | void |  | ) |

extern

Unload the OpenGL library previously loaded by SDL_GL_LoadLibrary().

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GL_LoadLibrary

## SDL_HasWindowSurface()

SDL_bool SDL_HasWindowSurface | ( | SDL_Window * | window | ) |

extern

Return whether the window has a surface associated with it.

Returns
  SDL_TRUE if there is a surface associated with the window, or SDL_FALSE otherwise.

Since
  This function is available since SDL 2.28.0.

See also
  SDL_GetWindowSurface

## SDL_HideWindow()

void SDL_HideWindow | ( | SDL_Window * | window | ) |

extern

Hide a window.

Parameters

  window | the window to hide.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_ShowWindow

## SDL_IsScreenSaverEnabled()

SDL_bool SDL_IsScreenSaverEnabled | ( | void |  | ) |

extern

Check whether the screensaver is currently enabled.

The screensaver is disabled by default since SDL 2.0.2. Before SDL 2.0.2 the screensaver was enabled by default.

The default can also be changed using SDL_HINT_VIDEO_ALLOW_SCREENSAVER.

Returns
  SDL_TRUE if the screensaver is enabled, SDL_FALSE if it is disabled.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_DisableScreenSaver
  SDL_EnableScreenSaver

## SDL_MaximizeWindow()

void SDL_MaximizeWindow | ( | SDL_Window * | window | ) |

extern

Make a window as large as possible.

Parameters

  window | the window to maximize.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_MinimizeWindow
  SDL_RestoreWindow

## SDL_MinimizeWindow()

void SDL_MinimizeWindow | ( | SDL_Window * | window | ) |

extern

Minimize a window to an iconic representation.

Parameters

  window | the window to minimize.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_MaximizeWindow
  SDL_RestoreWindow

## SDL_RaiseWindow()

void SDL_RaiseWindow | ( | SDL_Window * | window | ) |

extern

Raise a window above other windows and set the input focus.

Parameters

  window | the window to raise.

Since
  This function is available since SDL 2.0.0.

## SDL_RestoreWindow()

void SDL_RestoreWindow | ( | SDL_Window * | window | ) |

extern

Restore the size and position of a minimized or maximized window.

Parameters

  window | the window to restore.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_MaximizeWindow
  SDL_MinimizeWindow

## SDL_SetWindowAlwaysOnTop()

void SDL_SetWindowAlwaysOnTop | ( | SDL_Window * | window,
|  | SDL_bool | on_top )

extern

Set the window to always be above the others.

This will add or remove the window's SDL_WINDOW_ALWAYS_ON_TOP flag. This will bring the window to the front and keep the window above the rest.

Parameters

  window | The window of which to change the always on top state.
  on_top | SDL_TRUE to set the window always on top, SDL_FALSE to disable.

Since
  This function is available since SDL 2.0.16.

See also
  SDL_GetWindowFlags

## SDL_SetWindowBordered()

void SDL_SetWindowBordered | ( | SDL_Window * | window,
|  | SDL_bool | bordered )

extern

Set the border state of a window.

This will add or remove the window's SDL_WINDOW_BORDERLESS flag and add or remove the border from the actual window. This is a no-op if the window's border already matches the requested state.

You can't change the border state of a fullscreen window.

Parameters

  window | the window of which to change the border state.
  bordered | SDL_FALSE to remove border, SDL_TRUE to add border.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowFlags

## SDL_SetWindowBrightness()

int SDL_SetWindowBrightness | ( | SDL_Window * | window,
|  | float | brightness )

extern

Set the brightness (gamma multiplier) for a given window's display.

Despite the name and signature, this method sets the brightness of the entire display, not an individual window. A window is considered to be owned by the display that contains the window's center pixel. (The index of this display can be retrieved using SDL_GetWindowDisplayIndex().) The brightness set will not follow the window if it is moved to another display.

Many platforms will refuse to set the display brightness in modern times. You are better off using a shader to adjust gamma during rendering, or something similar.

Parameters

  window | the window used to select the display whose brightness will be changed.
  brightness | the brightness (gamma multiplier) value to set where 0.0 is completely dark and 1.0 is normal brightness.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowBrightness
  SDL_SetWindowGammaRamp

## SDL_SetWindowData()

void * SDL_SetWindowData | ( | SDL_Window * | window,
|  | const char * | name,
|  | void * | userdata )

extern

Associate an arbitrary named pointer with a window.

name is case-sensitive.

Parameters

  window | the window to associate with the pointer.
  name | the name of the pointer.
  userdata | the associated pointer.

Returns
  the previous value associated with name.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowData

## SDL_SetWindowDisplayMode()

int SDL_SetWindowDisplayMode | ( | SDL_Window * | window,
|  | const SDL_DisplayMode * | mode )

extern

Set the display mode to use when a window is visible at fullscreen.

This only affects the display mode used when the window is fullscreen. To change the window size when the window is not fullscreen, use SDL_SetWindowSize().

Parameters

  window | the window to affect.
  mode | the SDL_DisplayMode structure representing the mode to use, or NULL to use the window's dimensions and the desktop's format and refresh rate.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowDisplayMode
  SDL_SetWindowFullscreen

## SDL_SetWindowFullscreen()

int SDL_SetWindowFullscreen | ( | SDL_Window * | window,
|  | Uint32 | flags )

extern

Set a window's fullscreen state.

flags may be SDL_WINDOW_FULLSCREEN, for "real" fullscreen with a videomode change; SDL_WINDOW_FULLSCREEN_DESKTOP for "fake" fullscreen that takes the size of the desktop; and 0 for windowed mode.

Note that for some renderers, this function may trigger an SDL_RENDER_TARGETS_RESET event. Your application should be prepared to handle this event by reuploading textures!

Parameters

  window | the window to change.
  flags | SDL_WINDOW_FULLSCREEN, SDL_WINDOW_FULLSCREEN_DESKTOP or 0.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowDisplayMode
  SDL_SetWindowDisplayMode

## SDL_SetWindowGammaRamp()

int SDL_SetWindowGammaRamp | ( | SDL_Window * | window,
|  | const Uint16 * | red,
|  | const Uint16 * | green,
|  | const Uint16 * | blue )

extern

Set the gamma ramp for the display that owns a given window.

Set the gamma translation table for the red, green, and blue channels of the video hardware. Each table is an array of 256 16-bit quantities, representing a mapping between the input and output for that channel. The input is the index into the array, and the output is the 16-bit gamma value at that index, scaled to the output color precision.

Despite the name and signature, this method sets the gamma ramp of the entire display, not an individual window. A window is considered to be owned by the display that contains the window's center pixel. (The index of this display can be retrieved using SDL_GetWindowDisplayIndex().) The gamma ramp set will not follow the window if it is moved to another display.

Parameters

  window | the window used to select the display whose gamma ramp will be changed.
  red | a 256 element array of 16-bit quantities representing the translation table for the red channel, or NULL.
  green | a 256 element array of 16-bit quantities representing the translation table for the green channel, or NULL.
  blue | a 256 element array of 16-bit quantities representing the translation table for the blue channel, or NULL.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowGammaRamp

## SDL_SetWindowGrab()

void SDL_SetWindowGrab | ( | SDL_Window * | window,
|  | SDL_bool | grabbed )

extern

Set a window's input grab mode.

When input is grabbed, the mouse is confined to the window. This function will also grab the keyboard if SDL_HINT_GRAB_KEYBOARD is set. To grab the keyboard without also grabbing the mouse, use SDL_SetWindowKeyboardGrab().

If the caller enables a grab while another window is currently grabbed, the other window loses its grab in favor of the caller's window.

Parameters

  window | the window for which the input grab mode should be set.
  grabbed | SDL_TRUE to grab input or SDL_FALSE to release input.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetGrabbedWindow
  SDL_GetWindowGrab

## SDL_SetWindowHitTest()

int SDL_SetWindowHitTest | ( | SDL_Window * | window,
|  | SDL_HitTest | callback,
|  | void * | callback_data )

extern

Provide a callback that decides if a window region has special properties.

Normally windows are dragged and resized by decorations provided by the system window manager (a title bar, borders, etc), but for some apps, it makes sense to drag them from somewhere else inside the window itself; for example, one might have a borderless window that wants to be draggable from any part, or simulate its own title bar, etc.

This function lets the app provide a callback that designates pieces of a given window as special. This callback is run during event processing if we need to tell the OS to treat a region of the window specially; the use of this callback is known as "hit testing."

Mouse input may not be delivered to your application if it is within a special area; the OS will often apply that input to moving the window or resizing the window and not deliver it to the application.

Specifying NULL for a callback disables hit-testing. Hit-testing is disabled by default.

Platforms that don't support this functionality will return -1 unconditionally, even if you're attempting to disable hit-testing.

Your callback may fire at any time, and its firing does not indicate any specific behavior (for example, on Windows, this certainly might fire when the OS is deciding whether to drag your window, but it fires for lots of other reasons, too, some unrelated to anything you probably care about and when the mouse isn't actually at the location it is testing). Since this can fire at any time, you should try to keep your callback efficient, devoid of allocations, etc.

Parameters

  window | the window to set hit-testing on.
  callback | the function to call when doing a hit-test.
  callback_data | an app-defined void pointer passed to callback.

Returns
  0 on success or -1 on error (including unsupported); call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.4.

## SDL_SetWindowIcon()

void SDL_SetWindowIcon | ( | SDL_Window * | window,
|  | SDL_Surface * | icon )

extern

Set the icon for a window.

Parameters

  window | the window to change.
  icon | an SDL_Surface structure containing the icon for the window.

Since
  This function is available since SDL 2.0.0.

## SDL_SetWindowInputFocus()

int SDL_SetWindowInputFocus | ( | SDL_Window * | window | ) |

extern

Explicitly set input focus to the window.

You almost certainly want SDL_RaiseWindow() instead of this function. Use this with caution, as you might give focus to a window that is completely obscured by other windows.

Parameters

  window | the window that should get the input focus.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.5.

See also
  SDL_RaiseWindow

## SDL_SetWindowKeyboardGrab()

void SDL_SetWindowKeyboardGrab | ( | SDL_Window * | window,
|  | SDL_bool | grabbed )

extern

Set a window's keyboard grab mode.

Keyboard grab enables capture of system keyboard shortcuts like Alt+Tab or the Meta/Super key. Note that not all system keyboard shortcuts can be captured by applications (one example is Ctrl+Alt+Del on Windows).

This is primarily intended for specialized applications such as VNC clients or VM frontends. Normal games should not use keyboard grab.

When keyboard grab is enabled, SDL will continue to handle Alt+Tab when the window is full-screen to ensure the user is not trapped in your application. If you have a custom keyboard shortcut to exit fullscreen mode, you may suppress this behavior with SDL_HINT_ALLOW_ALT_TAB_WHILE_GRABBED.

If the caller enables a grab while another window is currently grabbed, the other window loses its grab in favor of the caller's window.

Parameters

  window | The window for which the keyboard grab mode should be set.
  grabbed | This is SDL_TRUE to grab keyboard, and SDL_FALSE to release.

Since
  This function is available since SDL 2.0.16.

See also
  SDL_GetWindowKeyboardGrab
  SDL_SetWindowMouseGrab
  SDL_SetWindowGrab

## SDL_SetWindowMaximumSize()

void SDL_SetWindowMaximumSize | ( | SDL_Window * | window,
|  | int | max_w,
|  | int | max_h )

extern

Set the maximum size of a window's client area.

Parameters

  window | the window to change.
  max_w | the maximum width of the window in pixels.
  max_h | the maximum height of the window in pixels.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowMaximumSize
  SDL_SetWindowMinimumSize

## SDL_SetWindowMinimumSize()

void SDL_SetWindowMinimumSize | ( | SDL_Window * | window,
|  | int | min_w,
|  | int | min_h )

extern

Set the minimum size of a window's client area.

Parameters

  window | the window to change.
  min_w | the minimum width of the window in pixels.
  min_h | the minimum height of the window in pixels.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowMinimumSize
  SDL_SetWindowMaximumSize

## SDL_SetWindowModalFor()

int SDL_SetWindowModalFor | ( | SDL_Window * | modal_window,
|  | SDL_Window * | parent_window )

extern

Set the window as a modal for another window.

Parameters

  modal_window | the window that should be set modal.
  parent_window | the parent window for the modal window.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.5.

## SDL_SetWindowMouseGrab()

void SDL_SetWindowMouseGrab | ( | SDL_Window * | window,
|  | SDL_bool | grabbed )

extern

Set a window's mouse grab mode.

Mouse grab confines the mouse cursor to the window.

Parameters

  window | The window for which the mouse grab mode should be set.
  grabbed | This is SDL_TRUE to grab mouse, and SDL_FALSE to release.

Since
  This function is available since SDL 2.0.16.

See also
  SDL_GetWindowMouseGrab
  SDL_SetWindowKeyboardGrab
  SDL_SetWindowGrab

## SDL_SetWindowMouseRect()

int SDL_SetWindowMouseRect | ( | SDL_Window * | window,
|  | const SDL_Rect * | rect )

extern

Confines the cursor to the specified area of a window.

Note that this does NOT grab the cursor, it only defines the area a cursor is restricted to when the window has mouse focus.

Parameters

  window | The window that will be associated with the barrier.
  rect | A rectangle area in window-relative coordinates. If NULL the barrier for the specified window will be destroyed.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.18.

See also
  SDL_GetWindowMouseRect
  SDL_SetWindowMouseGrab

## SDL_SetWindowOpacity()

int SDL_SetWindowOpacity | ( | SDL_Window * | window,
|  | float | opacity )

extern

Set the opacity for a window.

The parameter opacity will be clamped internally between 0.0f (transparent) and 1.0f (opaque).

This function also returns -1 if setting the opacity isn't supported.

Parameters

  window | the window which will be made transparent or opaque.
  opacity | the opacity value (0.0f - transparent, 1.0f - opaque).

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.5.

See also
  SDL_GetWindowOpacity

## SDL_SetWindowPosition()

void SDL_SetWindowPosition | ( | SDL_Window * | window,
|  | int | x,
|  | int | y )

extern

Set the position of a window.

The window coordinate origin is the upper left of the display.

Parameters

  window | the window to reposition.
  x | the x coordinate of the window in screen coordinates, or SDL_WINDOWPOS_CENTERED or SDL_WINDOWPOS_UNDEFINED.
  y | the y coordinate of the window in screen coordinates, or SDL_WINDOWPOS_CENTERED or SDL_WINDOWPOS_UNDEFINED.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowPosition

## SDL_SetWindowResizable()

void SDL_SetWindowResizable | ( | SDL_Window * | window,
|  | SDL_bool | resizable )

extern

Set the user-resizable state of a window.

This will add or remove the window's SDL_WINDOW_RESIZABLE flag and allow/disallow user resizing of the window. This is a no-op if the window's resizable state already matches the requested state.

You can't change the resizable state of a fullscreen window.

Parameters

  window | the window of which to change the resizable state.
  resizable | SDL_TRUE to allow resizing, SDL_FALSE to disallow.

Since
  This function is available since SDL 2.0.5.

See also
  SDL_GetWindowFlags

## SDL_SetWindowSize()

void SDL_SetWindowSize | ( | SDL_Window * | window,
|  | int | w,
|  | int | h )

extern

Set the size of a window's client area.

The window size in screen coordinates may differ from the size in pixels, if the window was created with SDL_WINDOW_ALLOW_HIGHDPI on a platform with high-dpi support (e.g. iOS or macOS). Use SDL_GL_GetDrawableSize() or SDL_GetRendererOutputSize() to get the real client area size in pixels.

Fullscreen windows automatically match the size of the display mode, and you should use SDL_SetWindowDisplayMode() to change their size.

Parameters

  window | the window to change.
  w | the width of the window in pixels, in screen coordinates, must be > 0.
  h | the height of the window in pixels, in screen coordinates, must be > 0.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowSize
  SDL_SetWindowDisplayMode

## SDL_SetWindowTitle()

void SDL_SetWindowTitle | ( | SDL_Window * | window,
|  | const char * | title )

extern

Set the title of a window.

This string is expected to be in UTF-8 encoding.

Parameters

  window | the window to change.
  title | the desired window title in UTF-8 format.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowTitle

## SDL_ShowWindow()

void SDL_ShowWindow | ( | SDL_Window * | window | ) |

extern

Show a window.

Parameters

  window | the window to show.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HideWindow
  SDL_RaiseWindow

## SDL_UpdateWindowSurface()

int SDL_UpdateWindowSurface | ( | SDL_Window * | window | ) |

extern

Copy the window surface to the screen.

This is the function you use to reflect any changes to the surface on the screen.

This function is equivalent to the SDL 1.2 API SDL_Flip().

Parameters

  window | the window to update.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowSurface
  SDL_UpdateWindowSurfaceRects

## SDL_UpdateWindowSurfaceRects()

int SDL_UpdateWindowSurfaceRects | ( | SDL_Window * | window,
|  | const SDL_Rect * | rects,
|  | int | numrects )

extern

Copy areas of the window surface to the screen.

This is the function you use to reflect changes to portions of the surface on the screen.

This function is equivalent to the SDL 1.2 API SDL_UpdateRects().

Note that this function will update at least the rectangles specified, but this is only intended as an optimization; in practice, this might update more of the screen (or all of the screen!), depending on what method SDL uses to send pixels to the system.

Parameters

  window | the window to update.
  rects | an array of SDL_Rect structures representing areas of the surface to copy, in pixels.
  numrects | the number of rectangles.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetWindowSurface
  SDL_UpdateWindowSurface

## SDL_VideoInit()

int SDL_VideoInit | ( | const char * | driver_name | ) |

extern

Initialize the video subsystem, optionally specifying a video driver.

This function initializes the video subsystem, setting up a connection to the window manager, etc, and determines the available display modes and pixel formats, but does not initialize a window or graphics mode.

If you use this function and you haven't used the SDL_INIT_VIDEO flag with either SDL_Init() or SDL_InitSubSystem(), you should call SDL_VideoQuit() before calling SDL_Quit().

It is safe to call this function multiple times. SDL_VideoInit() will call SDL_VideoQuit() itself if the video subsystem has already been initialized.

You can use SDL_GetNumVideoDrivers() and SDL_GetVideoDriver() to find a specific driver_name.

Parameters

  driver_name | the name of a video driver to initialize, or NULL for the default driver.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetNumVideoDrivers
  SDL_GetVideoDriver
  SDL_InitSubSystem
  SDL_VideoQuit

## SDL_VideoQuit()

void SDL_VideoQuit | ( | void |  | ) |

extern

Shut down the video subsystem, if initialized with SDL_VideoInit().

This function closes all windows, and restores the original video mode.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_VideoInit